// _Wړ

// _W[hNX
function DungeonMode(dungeonModel, partyModel, pcModel, fieldView, textView, selectionMode, itemMode) {
	this.dungeonModel = dungeonModel;
	this.partyModel = partyModel;
	this.pcModel = pcModel;
	this.fieldView = fieldView;
	this.textView = textView;
	this.itemMode = itemMode;
	this.selectionMode = selectionMode;
}

// Jn
DungeonMode.prototype.start = function() {
	KeyManager_addListener(this);
	this.statusView = 1;
	this.stop = 0;
	this.inStone = 0;
	this.party = this.partyModel[Party];
	this.pc = this.partyModel[Party].pc;
	this.dungeonModel.mapLoad(this.party.floor);
	this.roomCheck = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);

	var room = this.room.charAt(this.party.x + this.party.y * MAP_SIZE_X);
	room = ch32to10(room);
	if (room > 0) { this.roomCheck[room - 1] = 1; }

	this.party.check();
	this.mapCheck();

	this.mode = 'camp';
	if (MusicOn) { musicStart("CAMP"); }
	save(this.pcModel, this.partyModel);
	this.camp(0);

}

// L[ꂽƂ
DungeonMode.prototype.onKeyPress = function(key) {

	if (key == 'r' || key == 'R') {
		Reset = 1;
		gameMode.init(true);
		return;
	}

	if (this.stop) {
		if (this.mode == 'message') {
			this.stop = 0, this.mode = 'move', key = 'none';
		} else if (this.mode == 'message2') {
			this.stop = 0, this.mode = 'move', key = 'move';
		} else if (this.mode == 'campReorganize_1') {
			if (key == '5' || key == 'z' || key == 'Z') {
				this.stop = 0;
				var i;
				for (i = 0; i < this.sortC.length; i++) {
					this.sortC[i] = this.pc[this.sortC[i]];
				}
				for (i = 0; i < this.sortC.length; i++) {
					this.pc[i] = this.sortC[i];
				}
				this.mode = 'camp';
				this.camp(1);
				return;
			} else if (key == '0' || key == 'x' || key == 'X') {
				this.stop = 0;
				var i, tmp = 0;
				for (i = this.sortC.length - 1; i >= 0; i--) {
					if (this.pcModel[this.pc[this.sortC[i]]].cnatMove) {
						this.sortC[i] = -1;
						continue;
					}
					this.sortC[i] = -1;
					tmp++;
					if (tmp >= 2) { break; }
				}
				this.mode = 'campReorganize';
				this.camp(this.pcNum);
				return;
			} else {
				return;
			}
		} else if (this.mode == 'subMenu') {
			this.stop = 0;
			this.mode = 'subMenuSearch';
			this.camp(0);
			return;
		} else if (this.mode == 'subMenuSearch') {
			this.stop = 0;
			this.mode = 'subMenu';
			this.camp(1);
			return;
		} else if (this.mode == 'annihilate') {
			if (key == '5' || key == 'z' || key == 'Z' || key == '0' || key == 'x' || key == 'X') {
				Party = -1;
				KeyManager_removeListener(this);
				gameMode.townMode.start();
				save(this.pcModel, this.partyModel);
				return;
			} else { return; }
		} else if (this.mode == 'return') {
			this.returnCastle(1);
			return;
		} else if (this.mode == 'monster2' || this.mode == 'itemGet') {
			this.stop = 0;
			this.textView.message(32, 10, 'center', 'T܂H\n\n@͂\n@@', 'center');
			var choice = new Array('1', '1');
			this.selectionMode.startNon(this, choice, 27, 19, 0);
			this.fieldView.update();
			return;
		} else if (this.mode == 'back') {
			this.stop = 0, this.mode = 'move', key = 'none';
		} else if (this.mode == 'wordInput') {
			var pass = prompt("t́H", "");
			var check = 1;
			if (pass != null && pass != '') {
				if(Ie){
					var res = escape(pass);
					var pos = res.indexOf("%00");
					if(pos != -1){ res = res.substr(0,pos); }
					pass = unescape(res);
				}
				if (pass == this.point[4]) {
					check = 0;
					this.textView.message(36, 32, 'center', this.point[2], 'center');
					this.fieldView.update();
					this.mode = 'wordInput2';
					return;
				}
			}
			if (check) {
				this.mode = 'message';
				this.textView.message(36, 32, 'center', this.point[3], 'center');
				this.fieldView.update();
				return;
			}
		} else if (this.mode == 'wordInput2') {
			this.stop = 0;
			this.mode = 'itemGet2';
			this.enter(0);
			return;
		}
	}

	if (KeyFlag) {
		this.movePre = 'none';
		var wallHit = 0, move = 0, back = 0, point, str;
		var i, tmp, dead = 1, turn = 0;
		for (i = 0; i < this.pc.length; i++) {
			if (this.pc[i] > 0) {
				if (!this.pcModel[this.pc[i]].cantMove) {
					dead = 0;
					break;
				}
			}
		}
		if (dead) {
			this.annihilate();
			return;
		}

		if (key == 'move') {
			move = 1;
		} else if (key == '8' || key == 'u' || key == 'U') {
			if (this.dungeonModel.wall == '0') {
				this.goForward();
				move = 1;
			} else { wallHit = 1; }
		} else if (key == '4' || key == 'h' || key == 'H') {
			if (this.party.direction == 'north') {
				this.party.direction = 'west';
			} else if (this.party.direction == 'west') {
				this.party.direction = 'south';
			} else if (this.party.direction == 'south') {
				this.party.direction = 'east';
			} else if (this.party.direction == 'east') {
				this.party.direction = 'north';
			}
			turn = 1;
		} else if (key == '6' || key == 'k' || key == 'K') {
			if (this.party.direction == 'north') {
				this.party.direction = 'east';
			} else if (this.party.direction == 'east') {
				this.party.direction = 'south';
			} else if (this.party.direction == 'south') {
				this.party.direction = 'west';
			} else if (this.party.direction == 'west') {
				this.party.direction = 'north';
			}
			turn = 1;
		} else if (key == '2' || key == 'n' || key == 'N') {
			KeyFlag = 0;
			back = 1;
			if (this.party.direction == 'north') {
				this.party.direction = 'east';
			} else if (this.party.direction == 'east') {
				this.party.direction = 'south';
			} else if (this.party.direction == 'south') {
				this.party.direction = 'west';
			} else if (this.party.direction == 'west') {
				this.party.direction = 'north';
			}
			this.dungeonModel.visionSet(this.party.x, this.party.y, this.party.direction, this.party.bright);
			this.fieldView.dungeonViewSet();
			if (this.statusView) { this.textView.partyStatus(); }
			this.fieldView.update();
			if (this.party.direction == 'north') {
				this.party.direction = 'east';
			} else if (this.party.direction == 'east') {
				this.party.direction = 'south';
			} else if (this.party.direction == 'south') {
				this.party.direction = 'west';
			} else if (this.party.direction == 'west') {
				this.party.direction = 'north';
			}
		} else if (key == '5' || key == 'z' || key == 'Z') {
			if (this.dungeonModel.wall != '1') {
				if (this.dungeonModel.wall != '0') {
					if (SeOn) { seSounded("KICKDOOR"); }
				}
				this.goForward();
				move = 1;
			} else { wallHit = 1; }
		} else if (key == '7' || key == 'y' || key == 'Y') {
			if (this.dungeonModel.vision[1] == '0') {
				this.goLeft();
				move = 1;
			} else { wallHit = 1; }
		} else if (key == '9' || key == 'i' || key == 'I') {
			if (this.dungeonModel.vision[2] == '0') {
				this.goRight();
				move = 1;
			} else { wallHit = 1; }
		} else if (key == '0' || key == 'x' || key == 'X') {
			this.mode = 'camp';
			if (MusicOn) { musicStart("CAMP"); }
			save(this.pcModel, this.partyModel);
			this.camp(0);
			return;
		} else if (key == '3' || key == 's' || key == 'S') {
			if (this.statusView) { this.statusView = 0; }
			else { this.statusView = 1; }
		} else if (key == '1' || key == 'a' || key == 'A') {
			this.mode = 'subMenu';
			this.pt = -1;
			this.camp(0);
			return;
		}
		this.mapCheck();
		this.dungeonModel.visionSet(this.party.x, this.party.y, this.party.direction, this.party.bright);
		this.fieldView.dungeonViewSet();

		if (back){
			var id = setTimeout("moveAfter()", 100);
			return;
		}

		if (wallHit) {
			this.textView.alert(25, 18, 1, 'ĂI');
		} else if (this.dungeonModel.vision[0] == 'd') {
			this.textView.alert(25, 18, 1, '܂݂I');
			this.party.bright = 0;
		}

		var dMv = this.dungeonModel.vision[0];
		if ((move || turn) && dMv != 'f' && dMv != 'g' && dMv != 'h' && dMv != 'i' && dMv != 'j' && dMv != 'k' && dMv != 'l') {
			var monster = new Array(0,0,0,0);
			var room = this.room.charAt(this.party.x + this.party.y * MAP_SIZE_X);
			room = ch32to10(room);
			if (room > 0) {
				if (!this.roomCheck[room - 1]) {
					var roomOn = 0, box = 1;
					var  floor = this.party.floor;
					if (floor == -4 && room == 10) {
						roomOn = 1, box = -1;
					} else if (floor == -4 && room == 1) {
						roomOn = 1, monster[0] = 47;
						box = 2;
					} else if (floor == -6 && room == 1 && this.party.itemHaveCheck(1009) == -1) {
						roomOn = 1, monster[0] = 75;
						box = 2;
					} else if (floor == -10 && room == 1) {
						roomOn = 1;
						if (this.party.itemHaveCheck(1001) == -1 && this.party.titleCheck() == -1) {
							monster[0] = 111, box = 2;
						} else { monster[0] = 110; }
					} else if (dice(1,1000) <= 990) {
						roomOn = 1;
					}
					if (roomOn) {
						this.textView.partyStatus();
						gameMode.battleMode.room = room - 1;
						gameMode.battleMode.start(monster, box);
						return;
					} else {
						this.roomCheck[room - 1] = 1;
					}
				}
			}
			if (dice(1, 1000) <= 10) {
				this.textView.partyStatus();
				gameMode.battleMode.room = -1;
				gameMode.battleMode.start(monster, 0);
				return;
			}
		}

		if (move) {
			this.partyHpPlus();
			if (this.dungeonModel.vision[0] == 'a') {
				this.mode = 'up';
				this.upDownSel(0);
				return;
			} else if (this.dungeonModel.vision[0] == 'b') {
				this.mode = 'down';
				this.upDownSel(0);
				return;
			} else if (this.dungeonModel.vision[0] == 'c') {
				KeyFlag = 0;
				this.fieldView.viewClear();
				if (this.statusView) { this.textView.partyStatus(); }
				this.fieldView.update();
				tmp = dice(1, 4);
				if (tmp == 1) {
					this.party.direction = 'north';
				} else if (tmp == 2) {
					this.party.direction = 'east';
				} else if (tmp == 3) {
					this.party.direction = 'south';
				} else if (tmp == 4) {
					this.party.direction = 'west';
				}
				this.dungeonModel.visionSet(this.party.x, this.party.y, this.party.direction, this.party.bright);
				this.fieldView.dungeonViewSet();
				var id = setTimeout("moveAfter()", 100);
				return;
			} else if (this.dungeonModel.vision[0] == 'e') {
				this.mode = 'message';
				this.stop = 1;
				this.textView.alert(25, 18, 1, 'sbgI');
				if (SeOn) { seSounded("ATTACKHIT"); }
				var lvBonus, classBonus, r, pc, f;
				f = this.party.floor * -2;
				for (i = 0; i < this.pc.length; i++) {
					if (this.pc[i] == 0) { break; }
					pc = this.pcModel[this.pc[i]];
					lvBonus = Math.floor(pc.level / 3);
					if (lvBonus > 20) { lvBonus = 20; }
					if (pc.pcClass == 3 || pc.pcClass == 7) {
						classBonus = 20;
					} else { classBonus = 0; }
					r = pc.abi[4] + pc.abi[5];
					r += lvBonus + classBonus;
					if (r > 90) { r = 90; }
					if (dice(1, 100) > r) {
						tmp = dice(1, 4 + f) * -1;
					} else { tmp = 0; }
					pc.hpCtrl(tmp);
				}
			} else if (this.dungeonModel.vision[0] == 'f') {
				this.mode = 'message2';
				this.stop = 1;
				this.textView.alert(25, 18, 1, 'V[gI');
				if (SeOn) { seSounded("STUN"); }
				point = warpPoint(this.party.floor, this.party.x, this.party.y);
				this.party.x = point[0], this.party.y = point[1];
				this.party.floor -= 1;
				this.dungeonModel.mapLoad(this.party.floor);
				this.roomCheck = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
				save(this.pcModel, this.partyModel);
			} else if (this.dungeonModel.vision[0] == 'g') {
				point = elevator(this.party.floor, this.party.x, this.party.y);
				tmp = -1;
				if (point.length > 0) {
					for (i = 0; i < point.length; i++) {
						if (point[i] == (this.party.floor * -1)) {
							tmp = i;
							break;
						}
					}
					if (tmp >= 0) {
						this.mode = 'elevator';
						this.elevatorSel(tmp);
					}
				}
				if (tmp >= 0) { return; }
			} else if (this.dungeonModel.vision[0] == 'h') {
				str = getMessage(this.party.floor, this.party.x, this.party.y);
				if (str != '') {
					this.mode = 'message';
					this.stop = 1;
					this.textView.message(36, 32, 'center', str, 'center');
				}
			} else if (this.dungeonModel.vision[0] == 'i') {
				KeyFlag = 0;
				point = warpPoint(this.party.floor, this.party.x, this.party.y);
				this.party.x = point[0], this.party.y = point[1];
				this.mapCheck();
				this.fieldView.viewClear();
				if (this.statusView) { this.textView.partyStatus(); }
				this.fieldView.update();
				this.dungeonModel.visionSet(this.party.x, this.party.y, this.party.direction, this.party.bright);
				this.fieldView.dungeonViewSet();
				var id = setTimeout("moveAfter()", 100);
				return;
			} else if (this.dungeonModel.vision[0] == 'k') {
				this.point = getEvent(this.party.floor, this.party.x, this.party.y);
				str = getMessage(this.party.floor, this.party.x, this.party.y);
				if (this.point.length > 0) {
					if (this.point[0] == 1) {
						this.returnCastle(1);
						return;
					} else if (this.point[0] == 2) {
						this.mode = 'return';
						this.stop = 1;
						this.textView.message(36, 32, 'center', str, 'center');
					} else if (this.point[0] == 10) {
						this.mode = 'monster2';
						this.stop = 1;
						this.textView.message(36, 32, 'center', str, 'center');
					} else if (this.point[0] == 20) {
						if (this.party.itemHaveCheck(this.point[1]) == -1) {
							this.mode = 'itemGet';
							this.stop = 1;
							this.textView.message(36, 32, 'center', str, 'center');
						}
					} else if (this.point[0] == 30) {
						if (this.party.itemHaveCheck(this.point[3]) == -1) {
							this.mode = 'back';
							this.party.x = this.point[1];
							this.party.y = this.point[2];
							this.stop = 1;
							this.textView.message(36, 32, 'center', str, 'center');
						}
					} else if (this.point[0] == 31) {
						if (this.party.itemHaveCheck(this.point[3]) == -1 || this.party.itemHaveCheck(this.point[4]) == -1) {
							this.mode = 'back';
							this.party.x = this.point[1];
							this.party.y = this.point[2];
							this.stop = 1;
							this.textView.message(36, 32, 'center', str, 'center');
						}
					} else if (this.point[0] == 40) {
						this.mode = 'message';
						this.stop = 1;
						this.textView.message(36, 32, 'center', str, 'center');
						this.roomCheck = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
						if (SeOn) { seSounded("ALARM"); }
					} else if (this.point[0] == 50) {
						this.mode = 'message';
						this.stop = 1;
						if (this.party.itemHaveCheck(1001) >= 0 || this.party.titleCheck() >= 0) {
							str = this.point[1];
						}
						this.textView.message(36, 32, 'center', str, 'center');
					} else if (this.point[0] == 51) {
						this.mode = 'message';
						this.stop = 1;
						if (this.party.itemHaveCheck(1009) >= 0) {
							str = this.point[1];
						}
						this.textView.message(36, 32, 'center', str, 'center');
					} else if (this.point[0] == 60) {
						this.mode = 'message';
						this.stop = 1;
						this.party.recoverMp();
						this.textView.message(36, 32, 'center', str, 'center');
					} else if (this.point[0] == 70) {
						if (this.party.itemHaveCheck(this.point[1]) == -1) {
							this.mode = 'wordInput';
							this.stop = 1;
							this.textView.message(36, 32, 'center', str, 'center');
						}
					}
				}
			} else if (this.dungeonModel.vision[0] == 'l') {
				this.fieldView.viewClear();
				this.textView.alert(25, 18, 1, '΂̒ɂ');
				for (i = 0; i < this.pc.length; i++) {
					if (this.pc[i] == 0) { break; }
					this.pcModel[this.pc[i]].hpCtrl(-9999);
				}
				this.inStone = 1;
			}
		}
		if (this.statusView) { this.textView.partyStatus(); }
		this.fieldView.update();
		if (wallHit && SeOn) { seSounded("WALL"); }
		this.mapCheck();
	}
}

// 񕜌
DungeonMode.prototype.partyHpPlus = function() {
	var i, pc;
	for (i = 0; i < this.pc.length; i++) {
		if (this.pc[i] == 0) { break; }
		pc = this.pcModel[this.pc[i]];
		pc.hpCtrl(pc.hpPlus);
		if (pc.state == 1 || pc.state == 11) {
			if (dice(1, 1000) <= 50) {
				if (pc.state == 1) { pc.state = 0; }
				else { pc.state = 10; }
			}
		}
	}
}

// A
DungeonMode.prototype.returnCastle = function(warp) {
	if (warp) { if (SeOn) { seSounded("SPELLWARP"); } }
	this.party.floor = 0;
	this.party.bright = 0;
	this.party.protection = 0;
	this.party.discrimination = 0;
	this.party.check();
	KeyManager_removeListener(this);
	gameMode.townMode.start();
	save(this.pcModel, this.partyModel);
}

// }bvʉ߃`FbN
DungeonMode.prototype.mapCheck = function() {
	if (MapCheck[(this.party.floor * -1) - 1][this.party.x + this.party.y * MAP_SIZE_X] == 0) {
		MapCheck[(this.party.floor * -1) - 1][this.party.x + this.party.y * MAP_SIZE_X] = 1;
	}
}

// Oi
DungeonMode.prototype.goForward = function() {
	this.movePre = 'forward';
	if (this.party.bright > 0 && this.party.bright <= 40) {
		this.party.bright--;
	}
	if (this.party.direction == 'north') {
		this.party.y = this.dungeonModel.pointLoop(this.party.y+1, this.dungeonModel.sizeY);
	} else if (this.party.direction == 'west') {
		this.party.x = this.dungeonModel.pointLoop(this.party.x-1, this.dungeonModel.sizeX);
	} else if (this.party.direction == 'south') {
		this.party.y = this.dungeonModel.pointLoop(this.party.y-1, this.dungeonModel.sizeY);
	} else if (this.party.direction == 'east') {
		this.party.x = this.dungeonModel.pointLoop(this.party.x+1, this.dungeonModel.sizeX);
	}
}

// ړ
DungeonMode.prototype.goLeft = function() {
	this.movePre = 'left';
	if (this.party.bright > 0 && this.party.bright <= 40) {
		this.party.bright--;
	}
	if (this.party.direction == 'north') {
		this.party.x = this.dungeonModel.pointLoop(this.party.x-1, this.dungeonModel.sizeY);
	} else if (this.party.direction == 'west') {
		this.party.y = this.dungeonModel.pointLoop(this.party.y-1, this.dungeonModel.sizeX);
	} else if (this.party.direction == 'south') {
		this.party.x = this.dungeonModel.pointLoop(this.party.x+1, this.dungeonModel.sizeY);
	} else if (this.party.direction == 'east') {
		this.party.y = this.dungeonModel.pointLoop(this.party.y+1, this.dungeonModel.sizeX);
	}
}

// Eړ
DungeonMode.prototype.goRight = function() {
	this.movePre = 'right';
	if (this.party.bright > 0 && this.party.bright <= 40) {
		this.party.bright--;
	}
	if (this.party.direction == 'north') {
		this.party.x = this.dungeonModel.pointLoop(this.party.x+1, this.dungeonModel.sizeY);
	} else if (this.party.direction == 'west') {
		this.party.y = this.dungeonModel.pointLoop(this.party.y+1, this.dungeonModel.sizeX);
	} else if (this.party.direction == 'south') {
		this.party.x = this.dungeonModel.pointLoop(this.party.x-1, this.dungeonModel.sizeY);
	} else if (this.party.direction == 'east') {
		this.party.y = this.dungeonModel.pointLoop(this.party.y-1, this.dungeonModel.sizeX);
	}
}

// Gx[^I
DungeonMode.prototype.elevatorSel = function(num) {
	var point = elevator(this.party.floor, this.party.x, this.party.y);
	this.textView.message(36, 32, 'center', 'ɂ̈󂪂{^\n\nǂꂩĂ', 'left');
	var choice = new Array(0);
	for (var i = 0; i < point.length; i++) {
		choice[i] = 'a' + hzNum(point[i], 0);
	}
	if (this.statusView) { this.textView.partyStatus(); }
	this.selectionMode.start(this, choice, 26, 33, num);
	this.fieldView.update();
}

// ㉺I
DungeonMode.prototype.upDownSel = function(num) {
	if (this.mode == 'up') {
		this.textView.message(36, 32, 'center', 'nVSB@@g܂H@@@@@@\n\n͂@@@@@@@\n@@@@@@', 'right');
		var choice = new Array('1', '1');
		this.selectionMode.startNon(this, choice, 31, 28, num);
	} else if (this.mode == 'down') {
		this.textView.message(36, 32, 'center', 'nVSB@@g܂H@@@@@\n\n͂@@@@@@@\n@@@@@@', 'right');
		var choice = new Array('1', '1');
		this.selectionMode.startNon(this, choice, 31, 28, num);
	}
	if (this.statusView) { this.textView.partyStatus(); }
	this.fieldView.update();
}

// S
DungeonMode.prototype.annihilate = function() {
	this.mode = 'annihilate';
	this.stop = 1;
	this.fieldView.viewClear();
	this.textView.textNonFrame(FIELD_SIZE_X, FIELD_SIZE_Y);
	var i, x, xx, y, state;

	for (i = 0; i < this.pc.length; i++) {
		if (this.pc[i] == 0) { break; }
		this.pcModel[this.pc[i]].acPlus = 0;
		state = this.pcModel[this.pc[i]].state;
		if (state != 5 && state != 6 && state != 7) {
			this.pcModel[this.pc[i]].hpCtrl(-9999);
		}
		if (i == 0) { x = 16, y = 38; }
		else if (i == 1) { x = 2, y = 34; }
		else if (i == 2) { x = 30, y = 34; }
		else if (i == 3) { x = 16, y = 20; }
		else if (i == 4) { x = 2, y = 16; }
		else if (i == 5) { x = 30, y = 16; }
		this.textView.write(x, y, '@@@QQQQQQ'), y--;
		this.textView.write(x, y, '@@^@@@@@@_'), y--;
		this.textView.write(x, y, '@@@q@@'), y--;
		this.textView.write(x, y, '@@@@@@@@@'), y--;
		this.textView.write(x, y, '@@@@@@@'), y--;
		this.textView.write(x, y, '@@@@@@@@@'), y--;
		this.textView.write(x, y, '@@@o@'), y--;
		this.textView.write(x, y, '@@@@@@@@@'), y--;
		this.textView.write(x, y, '@@@@@@@@@'), y--;
		this.textView.write(x, y, '@@@@@@@@@');
		xx = Math.ceil((x + 6) - this.pcModel[this.pc[i]].name.length / 2);
		this.textView.write(xx, y, this.pcModel[this.pc[i]].name), y--;
		this.textView.write(x, y, '@@@@@@@@@'), y--;
		this.textView.write(x, y, '@@@@@@@@@'), y--;
		this.textView.write(x, y, ''), y--;
		this.textView.write(x, y, '@@@@@@@@@@'), y--;
		this.textView.write(x, y, '');
	}

	this.textView.textSet('left', 39, 0);
	if (this.inStone) {
		while (true) {
			this.party.pcDelete(this.pc[0]);
			if (this.pc[0] == 0) { break; }
		}
	}

	this.fieldView.update();
	if (MusicOn) { musicStart("ANNIHILATE"); }
}

// pcIpZbg
DungeonMode.prototype.pcSortSet = function() {
	var i;
	this.sortO = new Array(0);
	for (i = 0; i < this.pc.length; i++) {
		if (this.pc[i] > 0) {
			this.sortO[i] = this.pc[i];
		} else { break; }
	}
}

// uׂṽR}hZbg
DungeonMode.prototype.inspectComSet = function(num) {
	var i, tmp, item, count = 0, pc = this.pcModel[num];
	this.com = new Array(0);
	if (pc.mSpell[0][0] + pc.mSpell[0][1] + pc.mSpell[0][2] + pc.pSpell[0][0] + pc.pSpell[0][1] + pc.pSpell[0][2] > 0 && !pc.cantMove && pc.state != 1 && pc.state != 11) {
		this.com[count] = 0, count++;
	}
	this.com[count] = 1, count++;
	tmp = 0;
	for (i = 0; i < 8; i++) {
		item = itemData(pc.item[i]);
		if (item[3] > 0) {
			tmp = 1;
			break;
		}
	}
	if (tmp) { this.com[count] = 2, count++; }
	this.com[count] = 3, count++;
	this.com[count] = 4;

	var choice = new Array(0);
	for (i = 0; i < this.com.length; i++) {
		if (this.com[i] == 0) { choice[i] = ''; }
		else if (this.com[i] == 1) { choice[i] = 'ACe'; }
		else if (this.com[i] == 2) { choice[i] = ''; }
		else if (this.com[i] == 3) { choice[i] = 'W߂'; }
		else if (this.com[i] == 4) { choice[i] = '߂'; }
	}
	return choice;
}

// ĕҐp`FbN
DungeonMode.prototype.reorganizeCheck = function() {
	var i, j, tmp = 0;
	for (i = 0; i < this.sortC.length; i++) {
		if (this.sortC[i] < 0) { tmp++; }
	}
	var check = new Array(tmp), rCheck = new Array(tmp), hit;
	tmp = 0;
	for (i = 0; i < this.sortC.length; i++) {
		hit = 1;
		for (j = 0; j < this.sortC.length; j++) {
			if (this.sortC[j] == i) {
				hit = 0;
				break;
			}
		}
		if (hit) {
			check[tmp] = i;
			tmp++;
			if (tmp >= check.length) { break; }
		}
	}
	var j = 0;
	this.alive = 0;
	for (i = 0; i < check.length; i++) {
		if (!this.pcModel[this.pc[check[i]]].cantMove) {
			this.alive++;
			rCheck[j] = check[i];
			j++;
		}
	}
	for (i = 0; i < check.length; i++) {
		if (this.pcModel[this.pc[check[i]]].cantMove) {
			rCheck[j] = check[i];
			j++;
		}
	}
	return rCheck;
}

// ĕҐ\
DungeonMode.prototype.reorganizeView = function() {
	this.textView.textFrameNonMargin(16, 8);
	var i, y = 6;
	for (i = 1; i <= 6; i++) {
		this.textView.write(1, y, hzNum(i, 1) + 'F');
		y--;
	}
	y = 6;
	for (i = 0; i < this.sortC.length; i++) {
		if (this.sortC[i] < 0) { break; }
		this.textView.write(3, y, this.pcModel[this.pc[this.sortC[i]]].name);
		y--;
	}
	this.textView.textSet('center', 35, 28);

	if (this.sortC[this.sortC.length-1] < 0) {
		this.textView.partyStatus();
	}

}

// `ҒT̃Xg
DungeonMode.prototype.searchList = function() {
	this.sortO = new Array(0);
	var tmp = 0, pc = this.pcModel, pt = this.partyModel;
	for (var i = 1; i < pc.length; i++) {
		if (pc[i].party >= 0) {
			if (pc[i].party != Party && pt[pc[i].party].floor == this.party.floor && pt[pc[i].party].x == this.party.x && pt[pc[i].party].y == this.party.y) {
				this.sortO[tmp] = i;
				tmp++;
			}
		}
	}
}

// ɂtʕ\
DungeonMode.prototype.spellPlus = function() {
	var text = '';
	if (this.dungeonModel.vision[0] == 'd') {
		this.party.bright = 0;
	}
	if (this.party.bright > 0 || this.party.protection || this.party.discrimination) {
		if (this.party.bright > 0) {
			text += '@\n';
		} else { text += '@@@@\n'; }
		if (this.party.discrimination) {
			text += '@ʁ@\n';
		} else { text += '@@@@\n'; }
		if (this.party.protection) {
			text += '@ی@';
		}
		this.textView.messageNonMargin(32, 35, text);
	}
}

// Lv
DungeonMode.prototype.camp = function(num) {
	this.fieldView.viewClear();
	if (this.mode == 'camp') {
		this.textView.titleMessage(38, 'Lv');
		this.spellPlus();
		this.textView.partyStatus();
		var choice = new Array('ׂ', 'ĕҐ', '');
		this.selectionMode.start(this, choice, 34, 'center', num);
	} else if (this.mode == 'campInspect') {
		this.textView.titleMessage(38, 'Lv');
		this.spellPlus();
		this.textView.alert(32, 18, 1, 'N𒲂ׂ܂H');
		this.textView.partyStatus();
		this.selectionMode.startNon(this, this.sortO, 6, 4, num);
	} else if (this.mode == 'campInspect_1') {
		this.textView.pcStatus(this.sortO[this.pcNum]);
		var choice = this.inspectComSet(this.sortO[this.pcNum]);
		this.selectionMode.start(this, choice, 25, 26, num);
	} else if (this.mode == 'campSpellSel') {
		this.textView.pcStatus(this.sortO[this.pcNum]);
		this.selectionMode.startSpell(this, this.sortO[this.pcNum], 'camp', -1, -1, '', -1);
	} else if (this.mode == 'campReorganize') {
		this.textView.titleMessage(38, 'Lv');
		this.spellPlus();
		this.reorganizeView();
		this.selectionMode.startNon(this, this.sortO, 6, 4, num);
	} else if (this.mode == 'campReorganize_1') {
		this.textView.titleMessage(38, 'Lv');
		this.spellPlus();
		this.reorganizeView();
	} else if (this.mode == 'subMenu') {
		this.textView.titleMessage(38, 'Tuj[');
		this.textView.partyStatus();
		var choice = new Array('`̒f', 'ԂT', 'ԂO', '߂');
		this.selectionMode.start(this, choice, 34, 'center', num);
	} else if (this.mode == 'subMenuSearch') {
		this.textView.titleMessage(38, 'Tuj[');
		this.textView.partyStatus();
		if (this.sortO.length == 0) {
			this.textView.alert(33, 18, 1, 'N܂B');
			this.stop = 1;
		} else {
			this.textView.alert(33, 18, 1, '̂');
			this.textView.textFrameNonMargin(35, this.pcModel.length + 1);
			var i, y = this.pcModel.length - 1, name;
			for (i = 0; i < this.sortO.length; i++) {
				name = gameMode.townMode.pcListNameSet(this.sortO[i]);
				this.textView.write(3, y, name);
				y--;
			}
			this.textView.textSet('center', 29, 29 - this.pcModel.length);
			this.selectionMode.startNonD(this, this.sortO, 28, 5, 32, num);
		}
	} else if (this.mode == 'subMenuDelete') {
		this.textView.titleMessage(38, 'Tuj[');
		this.textView.partyStatus();
		this.textView.alert(33, 18, 1, 'NO܂H');
		var i;
		this.sortO = new Array(0);
		for (i = 0; i < this.party.pc.length; i++) {
			if (this.party.pc[i] == 0) { break; }
			this.sortO[i] = this.party.pc[i];
		}
		if (num >= this.sortO.length) { num = this.sortO.length-1; }
		this.selectionMode.startNon(this, this.sortO, 6, 4, num);
	}
	this.fieldView.update();
}

// E
DungeonMode.prototype.rightEnter = function(num) {
	if (this.mode == 'up' || this.mode == 'down') {
		this.upDownSel(num);
	} else if (this.mode == 'elevator') {
		this.elevatorSel(num);
	} else if (this.mode == 'monster2' || this.mode == 'itemGet') {
		var choice = new Array('1', '1');
		this.selectionMode.startNon(this, choice, 27, 19, num);
		this.fieldView.update();
	} else if (this.mode == 'campInspect_1') {
		this.pcNum++;
		if (this.pcNum >= this.sortO.length) { this.pcNum = 0; }
		this.camp(0);
	} else if (this.mode == 'subMenuSearch') {
		num += 6;
		if (num >= this.sortO.length) { num = this.sortO.length-1; }
		this.camp(num);
	} else {
		this.camp(num);
	}

}

// 
DungeonMode.prototype.leftEnter = function(num) {
	if (this.mode == 'up' || this.mode == 'down') {
		this.upDownSel(num);
	} else if (this.mode == 'elevator') {
		this.elevatorSel(num);
	} else if (this.mode == 'monster2' || this.mode == 'itemGet') {
		var choice = new Array('1', '1');
		this.selectionMode.startNon(this, choice, 27, 19, num);
		this.fieldView.update();
	} else if (this.mode == 'campInspect_1') {
		this.pcNum--;
		if (this.pcNum < 0) { this.pcNum = this.sortO.length - 1; }
		this.camp(0);
	} else if (this.mode == 'subMenuSearch') {
		num -= 6;
		if (num < 0) { num = 0; }
		this.camp(num);
	} else {
		this.camp(num);
	}

}

// 
DungeonMode.prototype.enter = function(num) {
	if (this.mode == 'up') {
		if (num == 0) {
			this.mode = 'move';
			var point = upDownPoint(this.party.floor, this.party.x, this.party.y);
			this.party.x = point[0], this.party.y = point[1];
			this.party.floor++;
			if (this.party.floor == 0) {
				this.returnCastle(0);
			} else {
				this.dungeonModel.mapLoad(this.party.floor);
				this.roomCheck = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
				save(this.pcModel, this.partyModel);
				this.onKeyPress('move');
			}
		} else if (num == 1) {
			this.mode = 'move';
			this.onKeyPress('none');
		}
	} else if (this.mode == 'down') {
		if (num == 0) {
			this.mode = 'move';
			var point = upDownPoint(this.party.floor, this.party.x, this.party.y);
			this.party.x = point[0], this.party.y = point[1];
			this.party.floor--;
			this.dungeonModel.mapLoad(this.party.floor);
			this.roomCheck = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
			save(this.pcModel, this.partyModel);
			this.onKeyPress('move');
		} else if (num == 1) {
			this.mode = 'move';
			this.onKeyPress('none');
		}
	} else if (this.mode == 'elevator') {
		var point = elevator(this.party.floor, this.party.x, this.party.y);
		this.party.floor = point[num] * -1;
		this.dungeonModel.mapLoad(this.party.floor);
		this.roomCheck = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
		save(this.pcModel, this.partyModel);
		this.mode = 'move';
		this.onKeyPress('move');
	} else if (this.mode == 'camp') {
		if (num == 0) {
			this.mode = 'campInspect';
			this.pcSortSet();
			this.camp(0);
		} else if (num == 1) {
			if (this.pc[1] > 0) {
				this.mode = 'campReorganize';
				this.pcSortSet();
				this.sortC = new Array(this.sortO.length);
				for (var i = 0; i < this.sortC.length; i++) {
					this.sortC[i] = -1;
				}
			}
			this.camp(0);
		} else if (num == 2) {
			this.dungeonModel.mapLoad(this.party.floor);
			save(this.pcModel, this.partyModel);
			this.mode = 'move';
			if (MusicOn) { musicStart("DUNGEON"); }
			this.onKeyPress('move');
		}
	} else if (this.mode == 'campInspect') {
		this.pcNum = num;
		this.mode = 'campInspect_1';
		this.camp(0);
	} else if (this.mode == 'campInspect_1') {
		if (this.com[num] == 0) {
			this.mode = 'campSpellSel';
			num = 0;
		} else if (this.com[num] == 1) {
			this.itemMode.start('dungeon', this.sortO[this.pcNum]);
			return;
		} else if (this.com[num] == 2) {
			this.itemMode.equipmentStart('dungeon', this.sortO[this.pcNum]);
			return;
		} else if (this.com[num] == 3) {
			var gold = 0;
			for (var i = 0; i < this.pc.length; i++) {
				if (this.pc[i] > 0) {
					gold += this.pcModel[this.pc[i]].gold;
					this.pcModel[this.pc[i]].gold = 0;
				}
			}
			if (gold > 999999999999) { gold = 999999999999; }
			this.pcModel[this.sortO[this.pcNum]].gold = gold;
		} else if (this.com[num] == 4) {
			this.mode = 'campInspect';
			num = this.pcNum + 1;
			if (this.sortO.length <= num) { num = 0; }
		}
		this.camp(num);
	} else if (this.mode == 'campReorganize') {
		var i, j;
		if (!this.pcModel[this.pc[num]].cantMove) {
			for (i = 0; i < this.sortC.length; i++) {
				if (this.sortC[i] == num) { break; }
				else if (this.sortC[i] < 0) {
					this.sortC[i] = num;
					this.pcNum = num;
					break;
				}
			}
		}
		var check = this.reorganizeCheck();
		if (this.alive <= 1) {
			j = 0;
			for (i = 0; i < this.sortC.length; i++) {
				if (this.sortC[i] < 0) {
					this.sortC[i] = check[j];
					j++;
				}
			}
			this.mode = 'campReorganize_1';
			this.stop = 1;
		} else {
			while(true) {
				num++;
				if (this.sortC.length <= num) { num = 0; }
				j = 1;
				if (this.pcModel[this.pc[num]].cantMove) {
					j = 0;
				} else {
					for (i = 0; i < this.sortC.length; i++) {
						if (this.sortC[i] == num) {
							j = 0;
							break;
						}
					}
				}
				if (j) { break; }
			}
		}
		this.camp(num);
	} else if (this.mode == 'subMenu') {
		if (num == 0) {
			this.party.check();
			KeyManager_removeListener(this);
			save(this.pcModel, this.partyModel);
			Party = -1;
			gameMode.townMode.start();
		} else if (num == 1) {
			this.stop = 1;
			this.fieldView.viewClear();
			this.textView.titleMessage(38, 'Tuj[');
			this.textView.partyStatus();
			this.textView.alert(33, 18, 1, 'TĂ܂DDD');
			this.fieldView.update();
			this.searchList();
		} else if (num == 2) {
			if (this.party.pc[1] > 0) {
				this.mode = 'subMenuDelete';
				num = 0;
			}
			this.camp(num);
		} else if (num == 3) {
			this.mode = 'move';
			this.onKeyPress('none');
		}
	} else if (this.mode == 'subMenuSearch') {
		if (this.pc[5] > 0) {
			this.textView.alert(29, 20, 1, 'p[eB[tł');
			this.stop = 1;
			this.fieldView.update();
			return;
		}
		this.partyModel[this.pcModel[this.sortO[num]].party].pcDelete(this.sortO[num]);
		this.party.pcAdd(this.sortO[num]);
		this.searchList();
		if (this.sortO.length == 0) {
			this.mode = 'subMenu';
			this.camp(1);
		} else if (this.pc[5] > 0) {
			this.mode = 'subMenu';
			this.camp(1);
		} else {
			if (num >= this.sortO.length) {
				num = this.sortO.length-1;
			}
			this.camp(num);
		}
	} else if (this.mode == 'subMenuDelete') {
		if (this.pt < 0) {
			for (var i = 0; i < this.partyModel.length; i++) {
				if (this.partyModel[i].pc[0] == 0) {
					this.pt = i;
					break;
				}
			}
			var party = this.partyModel[this.pt];
			party.init();
			party.x = this.party.x, party.y = this.party.y;
			party.floor = this.party.floor;
			party.direction = this.party.direction;
		}
		var pcNum = this.party.pc[num];
		this.party.pcDelete(pcNum);
		this.partyModel[this.pt].pcAdd(pcNum);
		if (this.party.pc[1] == 0) {
			this.mode = 'subMenu';
			num = 2;
		}
		this.camp(num);
	} else if (this.mode == 'monster2') {
		if (num == 0) {
			var monster = new Array(0,0,0,0);
			monster[0] = this.point[1];
			this.textView.partyStatus();
			gameMode.battleMode.start(monster, 0);
		} else if (num == 1) {
			this.mode = 'move';
			this.onKeyPress('none');
		}
	} else if (this.mode == 'itemGet' || this.mode == 'itemGet2') {
		if (num == 0) {
			var tmp = this.party.itemGetCheck();
			if (tmp == -1) {
				this.textView.alert(28, 14, 1, 'ȏ㎝ĂȂII');
			} else {
				var pc2 = this.pcModel[this.pc[tmp]];
				var getItem = this.point[1] + 10000;
				pc2.getItem(getItem);
				var text = pc2.name + '@́@';
				var item = itemData(getItem);
				text += abbreviation('item', item[2]);
				if (this.mode == 'itemGet') {
					text += '@B';
				} else { text += '@ɓꂽB'; }
				this.textView.alert(28, 28, 1, text);
			}
			this.mode = 'message', this.stop = 1;
			this.fieldView.update();
		} else if (num == 1) {
			this.mode = 'move';
			this.onKeyPress('none');
		}
	}
}

// LZ
DungeonMode.prototype.cancel = function(num) {
	if (this.mode == 'up' || this.mode == 'down' || this.mode == 'elevator'|| this.mode == 'monster2' || this.mode == 'itemGet') {
		this.mode = 'move';
		this.onKeyPress('none');
	} else if (this.mode == 'camp') {
		this.dungeonModel.mapLoad(this.party.floor);
		save(this.pcModel, this.partyModel);
		this.mode = 'move';
		if (MusicOn) { musicStart("DUNGEON"); }
		this.onKeyPress('move');
	} else if (this.mode == 'campInspect') {
		this.mode = 'camp';
		this.camp(0);
	} else if (this.mode == 'campInspect_1') {
		this.mode = 'campInspect';
		num = this.pcNum + 1;
		if (this.sortO.length <= num) { num = 0; }
		this.camp(num);
	} else if (this.mode == 'campSpellSel') {
		this.mode = 'campInspect_1';
		this.camp(0);
	} else if (this.mode == 'campReorganize') {
		if (this.sortC[0] < 0) {
			this.mode = 'camp';
			this.camp(1);
		} else {
			var i, hit;
			for (i = 1; i < this.sortC.length; i++) {
				if (this.sortC[i] < 0) {
					hit = i-1;
					break;
				}
			}
			this.sortC[hit] = -1;
			this.camp(this.pcNum);
		}
	} else if (this.mode == 'subMenu') {
		this.mode = 'move';
		this.onKeyPress('none');
	} else if (this.mode == 'subMenuSearch') {
		this.mode = 'subMenu';
		this.camp(1);
	} else if (this.mode == 'subMenuDelete') {
		this.mode = 'subMenu';
		this.camp(2);
	}

}

// UԂA[vȂ
function moveAfter() {
	if (gameMode.dungeonModel.vision[0] == 'd') {
		gameMode.textView.alert(25, 18, 1, '܂݂I');
		gameMode.partyModel[Party].bright = 0;
	}
	if (gameMode.dungeonMode.statusView) {
		gameMode.textView.partyStatus();
	}
	gameMode.fieldView.update();
	KeyFlag = 1;
}


