// I

// I[hNX
function SelectionMode(fieldView, textView, pcModel) {
	this.fieldView = fieldView;
	this.textView = textView;
	this.pM = pcModel;
	this.spellSel = '';
	this.stop = 0;
	this.partyStatus = 0;
}

// Jn
SelectionMode.prototype.start = function(mode, choice, alignY, align, num) {
	KeyManager_addListener(this);
	this.selMode = 0;
	this.alignY = alignY;
	this.align = align;
	this.mode = mode;
	this.choice = choice;
	this.selected = num;
	this.len = 0;
	for (var i = 0; i < choice.length; i++) {
		if (choice[i].length > this.len) {
			this.len = choice[i].length;
		}
	}

	this.choiceSet();
}

// JniI\Ȃj
SelectionMode.prototype.startNon = function(mode, choice, alignY, align, num) {
	KeyManager_addListener(this);
	this.selMode = 1;
	this.alignY = alignY;
	this.align = align;
	this.mode = mode;
	this.choice = choice;
	this.selected = num;
	this.len = 1;

	this.choiceSetNon();
}

// JniI\ȂBIJ[\[\j
SelectionMode.prototype.startNonD = function(mode, choice, alignY, align, alignW, num) {
	KeyManager_addListener(this);
	this.selMode = 2;
	this.alignY = alignY;
	this.align = align;
	this.alignW = alignW;
	this.mode = mode;
	this.choice = choice;
	this.selected = num;
	this.len = 1;

	this.choiceSetNonD();
}

// IJn
SelectionMode.prototype.startSpell = function(mode, pcNum, stateMode, lv, kind, spellSel, selected) {
	KeyManager_addListener(this);
	this.selMode = 10;
	this.mode = mode;
	this.pcNum = pcNum;
	this.pc = this.pM[pcNum];
	this.party = gameMode.partyModel[Party];
	this.stateMode = stateMode;
	if (lv == -1) { this.lv = 0; }
	else { this.lv = lv; }
	if (kind == -1) {
		if (this.pc.pcClass == 2 || this.pc.pcClass == 4 || this.pc.pcClass == 6) {
			this.kind = 1;
		} else { this.kind = 0; }
	} else { this.kind = kind; }
	if (spellSel == '') { this.spellSel = 'level'; }
	else { this.spellSel = spellSel; }
	if (selected == -1) { this.selected = 0; }
	else { this.selected = selected; }

	this.spellList = this.textView.spellSelView(this.pcNum, this.stateMode, this.lv, this.kind, this.spellSel, this.selected);
}

// ĨZbg
SelectionMode.prototype.choiceSetNon = function() {
	this.textView.textNonFrame(this.len, this.choice.length);
	this.textView.write(0, this.choice.length - 1 - this.selected, '');
	this.textView.textSet(this.align, this.alignY, this.alignY - this.choice.length + 1);
}

// ĨZbgiIJ[\[\j
SelectionMode.prototype.choiceSetNonD = function() {
	this.textView.textNonFrame(this.len, this.choice.length);
	this.textView.write(0, this.choice.length - 1 - this.selected, '');
	this.textView.textSet(this.align, this.alignY, this.alignY - this.choice.length + 1);
	this.textView.textNonFrame(this.len, this.choice.length);
	this.textView.write(0, this.choice.length - 1 - this.selected, '');
	this.textView.textSet(this.align + this.alignW, this.alignY, this.alignY - this.choice.length + 1);
}

// ĨZbg
SelectionMode.prototype.choiceSet = function() {
	this.textView.textFrame(this.len + 6, this.choice.length + 4);
	var j = this.choice.length + 1;
	for (var i = 0; i < this.choice.length; i++) {
		this.textView.write(4, j - i, this.choice[i]);
	}

	this.textView.write(2, this.choice.length + 1 - this.selected, '');

	this.spellList = this.textView.textSet(this.align, this.alignY + 2, this.alignY - this.choice.length - 1);
}

// 
SelectionMode.prototype.mapView = function(floor, x, y, dir) {
	gameMode.dungeonModel.mapLoad(floor);
	var snMap = gameMode.dungeonModel.southNorthWall;
	var ewMap = gameMode.dungeonModel.eastWestWall;
	var spMap = gameMode.dungeonModel.space;
	var sn = new Array(MAP_SIZE_X * (MAP_SIZE_Y + 1));
	var ew = new Array((MAP_SIZE_X + 1) * MAP_SIZE_Y);
	var sp = new Array(MAP_SIZE_X * MAP_SIZE_Y);
	var others = new Array((MAP_SIZE_X + 1) * (MAP_SIZE_Y + 1));
	var mapCheck = MapCheck[(floor * -1) - 1];

	var i, j, tmp;
	this.textView.textNonFrame(42, 35);

	if (MapOn) {
		for (i = 0; i < sn.length; i++) { sn[i] = ''; }
		for (i = 0; i < ew.length; i++) { ew[i] = ''; }
		for (i = 0; i < sp.length; i++) { sp[i] = ''; }
		for (i = 0; i < others.length; i++) { others[i] = ''; }

		this.textView.write(4, 0, 'O@P@Q@R@S@T@U@V@W@X@`@a@b@c@d@e');
		j = 3;
		for (i = 0; i < 16; i++) {
			this.textView.write(0, j, hzNum(i, 2));
			j += 2;
		}

		var check = new Array(4);
		for (i = 0; i < MAP_SIZE_X; i++) {
			for (j = 0; j <= MAP_SIZE_Y; j++) {
				check[0] = mapCheck[i + loop(j, MAP_SIZE_Y) * MAP_SIZE_X];
				check[1] = mapCheck[i + loop(j-1, MAP_SIZE_Y) * MAP_SIZE_X];
				if (check[0] || check[1]) {
					if (j == MAP_SIZE_Y) {
						tmp = snMap[i + 0 * MAP_SIZE_X];
					} else { tmp = snMap[i + j * MAP_SIZE_X]; }
					if (tmp == 0) { sn[i + j * MAP_SIZE_X] = '@'; }
					else if (tmp == '1') {
						sn[i + j * MAP_SIZE_X] = '';
					} else if (tmp == '2' || tmp == '3') {
						sn[i + j * MAP_SIZE_X] = '';
					} else if (tmp == '4') {
						if (check[0] && check[1]) {
							sn[i + j * MAP_SIZE_X] = '';
						} else if (check[0]) {
							sn[i + j * MAP_SIZE_X] = '';
						} else {
							sn[i + j * MAP_SIZE_X] = '';
						}
					} else if (tmp == '5') {
						if (check[0] && check[1]) {
							sn[i + j * MAP_SIZE_X] = '';
						} else if (check[0]) {
							sn[i + j * MAP_SIZE_X] = '';
						} else {
							sn[i + j * MAP_SIZE_X] = '';
						}
					}
				}
			}
		}
		for (i = 0; i <= MAP_SIZE_X; i++) {
			for (j = 0; j < MAP_SIZE_Y; j++) {
				check[0] = mapCheck[loop(i-1, MAP_SIZE_X) + j * MAP_SIZE_X];
				check[1] = mapCheck[loop(i, MAP_SIZE_X) + j * MAP_SIZE_X];
				if (check[0] || check[1]) {
					if (i == MAP_SIZE_X) {
						tmp = ewMap[0 + j * MAP_SIZE_X];
					} else { tmp = ewMap[i + j * MAP_SIZE_X]; }
					if (tmp == '0') {
						ew[i + j * (MAP_SIZE_X + 1)] = '@';
					} else if (tmp == '1') {
						ew[i + j * (MAP_SIZE_X + 1)] = '';
					} else if (tmp == '2' || tmp == '3') {
						ew[i + j * (MAP_SIZE_X + 1)] = '';
					} else if (tmp == '6') {
						if (check[0] && check[1]) {
							ew[i + j * (MAP_SIZE_X + 1)] = '';
						} else if (check[0]) {
							ew[i + j * (MAP_SIZE_X + 1)] = '';
						} else {
							ew[i + j * (MAP_SIZE_X + 1)] = '';
						}
					} else if (tmp == '7') {
						if (check[0] && check[1]) {
							ew[i + j * (MAP_SIZE_X + 1)] = '';
						} else if (check[0]) {
							ew[i + j * (MAP_SIZE_X + 1)] = '';
						} else {
							ew[i + j * (MAP_SIZE_X + 1)] = '';
						}
					}
				}
			}
		}
		for (i = 0; i < MAP_SIZE_X; i++) {
			for (j = 0; j < MAP_SIZE_Y; j++) {
				if(mapCheck[i + j * MAP_SIZE_X]) {
					tmp = spMap[i + j * MAP_SIZE_X];
					if (tmp == 'a'){
						sp[i + j * MAP_SIZE_X] = '';
					} else if (tmp == 'b') {
						sp[i + j * MAP_SIZE_X] = '';
					} else if (tmp == 'g') {
						sp[i + j * MAP_SIZE_X] = 'd';
					} else if (tmp == 'l') {
						sp[i + j * MAP_SIZE_X] = '';
					} else {
						sp[i + j * MAP_SIZE_X] = '@';
					}
				}
			}
		}
		for (i = 0; i <= MAP_SIZE_X; i++) {
			for (j = 0; j <= MAP_SIZE_Y; j++) {
				if (j == 0) { check[0] = 0; }
				else {
					tmp = ew[i + (j-1) * (MAP_SIZE_X + 1)];
					if (tmp == '@') { check[0] = 0; }
					else if (tmp == '') { check[0] = 2; }
					else { check[0] = 1; }
				}
				if (i == 0) { check[1] = 0; }
				else {
					tmp = sn[(i-1) + j * MAP_SIZE_X];
					if (tmp == '@') { check[1] = 0; }
					else if (tmp == '') { check[1] = 2; }
					else { check[1] = 1; }
				}
				if (i == MAP_SIZE_X) { check[2] = 0; }
				else {
					tmp = sn[i + j * MAP_SIZE_X];
					if (tmp == '@') { check[2] = 0; }
					else if (tmp == '') { check[2] = 2; }
					else { check[2] = 1; }
				}
				if (j == MAP_SIZE_Y) { check[3] = 0; }
				else {
					tmp = ew[i + j * (MAP_SIZE_X + 1)];
					if (tmp == '@') { check[3] = 0; }
					else if (tmp == '') { check[3] = 2; }
					else { check[3] = 1; }
				}

				if (check[0] == 1 && check[1] == 1 && check[2] == 1 && check[3] == 1) {
					others[i + j * (MAP_SIZE_X + 1)] = '';
				} else if (check[1] == 1 && check[2] == 1 && check[3] == 1) {
					others[i + j * (MAP_SIZE_X + 1)] = '';
				} else if (check[0] == 1 && check[2] == 1 && check[3] == 1) {
					others[i + j * (MAP_SIZE_X + 1)] = '';
				} else if (check[0] == 1 && check[1] == 1 && check[3] == 1) {
					others[i + j * (MAP_SIZE_X + 1)] = '';
				} else if (check[0] == 1 && check[1] == 1 && check[2] == 1) {
					others[i + j * (MAP_SIZE_X + 1)] = '';
				} else if (check[0] == 1 && check[1] == 1) {
					others[i + j * (MAP_SIZE_X + 1)] = '';
				} else if (check[0] == 1 && check[2] == 1) {
					others[i + j * (MAP_SIZE_X + 1)] = '';
				} else if (check[1] == 1 && check[3] == 1) {
				others[i + j * (MAP_SIZE_X + 1)] = '';
				} else if (check[2] == 1 && check[3] == 1) {
					others[i + j * (MAP_SIZE_X + 1)] = '';
				} else if (check[1] == 1 || check[2] == 1) {
					others[i + j * (MAP_SIZE_X + 1)] = '';
				} else if (check[0] == 1 || check[3] == 1) {
					others[i + j * (MAP_SIZE_X + 1)] = '';
				} else if ((check[1] == 0 && check[2] == 0 && check[3] == 0) || (check[0] == 0 && check[2] == 0 && check[3] == 0) || (check[0] == 0 && check[1] == 0  && check[3] == 0) || (check[0] == 0 && check[1] == 0 && check[2] == 0)) {
					others[i + j * (MAP_SIZE_X + 1)] = '@';
				}
			}
		}

		for (j = 0; j <= MAP_SIZE_Y; j++) {
			tmp = '';
			for (i = 0; i < MAP_SIZE_X; i++) {
				tmp += others[i + j * (MAP_SIZE_X + 1)];
				tmp += sn[i + j * MAP_SIZE_X];
			}
			tmp += others[MAP_SIZE_X + j * (MAP_SIZE_X + 1)];
			this.textView.write(3, 2 + j * 2, tmp);
		}
		for (j = 0; j < MAP_SIZE_Y; j++) {
			tmp = '';
			for (i = 0; i < MAP_SIZE_X; i++) {
				tmp += ew[i + j * (MAP_SIZE_X + 1)];
				tmp += sp[i + j * MAP_SIZE_X];
			}
			tmp += ew[MAP_SIZE_X + j * (MAP_SIZE_X + 1)];
			this.textView.write(3, 3 + j * 2, tmp);
		}
	}

	j = 33;
	for (i = 1; i <= FLOOR_MAX; i++) {
		this.textView.write(39, j, 'a' + hzNum(i, 0));
		j--;
	}
	this.textView.write(38, 34 + floor, '');

	var line = this.textView.lineData;
	this.lineStock = new Array(0);
	for (i = 0; i < line.length; i++) {
		this.lineStock[i] = line[i];
	}

	if (MapOn) {
		if (dir == 'north') { tmp = ''; }
		else if (dir == 'south') { tmp = ''; }
		else if (dir == 'east') { tmp = ''; }
		else if (dir == 'west') { tmp = ''; }
		else if (dir == 'none') { tmp = ''; }
		if (dir != 'map') { this.textView.write(4 + x * 2, 3 + y * 2, tmp); }
	}

	if (dir != 'map') {
		this.textView.write(38, 10, 'F' + hzNum(x, 2));
		this.textView.write(38, 9, 'kF' + hzNum(y, 2));
		if (dir == 'north') { tmp = 'k'; }
		else if (dir == 'south') { tmp = ''; }
		else if (dir == 'east') { tmp = ''; }
		else if (dir == 'west') { tmp = ''; }
		else if (dir == 'none') { tmp = '@'; }
		this.textView.write(39, 7, tmp);
	}

	this.fieldView.viewClear();
	this.textView.textSet(1, 37, 3);
	this.fieldView.update();
}

//  2
SelectionMode.prototype.mapView_2 = function(x, y) {
	this.textView.textNonFrame(42, 35);

	for (var i = 0; i < this.lineStock.length; i++) {
		this.textView.lineData[i] = this.lineStock[i];
	}

	this.textView.write(38, 10, 'F' + hzNum(x, 2));
	this.textView.write(38, 9, 'kF' + hzNum(y, 2));
	if (MapOn) {
		this.textView.write(4 + x * 2, 3 + y * 2, '');
	}

	this.textView.textSet(1, 37, 3);
	this.fieldView.update();
}

// T pcI
SelectionMode.prototype.mapPc = function() {
	this.fieldView.viewClear();
	this.textView.alert(33, 18, 1, 'NT܂H');
	this.textView.textFrameNonMargin(35, this.pM.length + 1);
	var y = this.pM.length - 1, name;
	for (i = 1; i < this.pM.length; i++) {
		if (this.pM[i].name == '') { break; }
		name = gameMode.townMode.pcListNameSet(i);
		this.textView.write(3, y, name);
		y--;
	}
	this.textView.textSet('center', 29, 29 - this.pM.length);
	this.searchPc = 0;
}

// T pcI 2
SelectionMode.prototype.mapPc_2 = function() {
	var i, tmp;
	for (i = this.pM.length - 1; i >= 1; i--) {
		if (this.pM[i].name != '') {
			tmp = i;
			break;
		}
	}
	if (this.searchPc < 0) { this.searchPc = tmp - 1; }
	else if (this.searchPc >= tmp) { this.searchPc = 0; }

	this.textView.textNonFrame(1, this.pM.length - 1);
	this.textView.write(0, 17 - this.searchPc, '');
	tmp = this.pM.length - 2;
	this.textView.textSet(5, 28, 28 - tmp);
	this.textView.textNonFrame(1, this.pM.length - 1);
	this.textView.write(0, 17 - this.searchPc, '');
	this.textView.textSet(37, 28, 28 - tmp);
	this.fieldView.update();
}

// T pcʒu\
SelectionMode.prototype.mapPcEnter = function(num) {
	var pc = this.pM[num], text;
	if (pc.party >= 0) {
		var party = gameMode.partyModel[pc.party];
		if (party.floor == 0) {
			text = pc.name + '́DDD\n\n@@@nɂ܂';
			this.textView.message(34, 12, 'center', text, 'left');
			this.fieldView.update();
		} else if (pc.party == Party) {
			text = pc.name + '́DDD\n\n@@@ɂ܂';
			this.textView.message(34, 12, 'center', text, 'left');
			this.fieldView.update();
		} else {
			this.mapView(party.floor, party.x, party.y, 'none');
		}
	} else {
		text = pc.name + '́DDD\n\n@@@nɂ܂';
		this.textView.message(34, 12, 'center', text, 'left');
		this.fieldView.update();
	}

	this.stop = 1;
}

// @̎gp
SelectionMode.prototype.magic = function() {
	var spellEnd = 0;
	this.viewtext = '';
	if (this.stateMode == 'camp') {
		if (this.kind == 0) {
			if (this.lv == 0) {
				if (this.selected == 2) {
					if (this.spellSel == 'spell') {
						if (SeOn) { seSounded("SPELLRECITE"); }
						this.spellSel = 'mapView';
						this.stop = 1;
						this.mapView(this.party.floor, this.party.x, this.party.y, this.party.direction);
					} else {
						this.spellSel = 'spell';
						spellEnd = 1;
					}
				}
			} else if (this.lv == 1) {
				if (this.selected == 2) {
					if (this.spellSel == 'spell') {
						if (SeOn) { seSounded("SPELLRECITE"); }
						this.spellSel = 'mapPc';
						this.mapPc();
						this.mapPc_2();
					} else {
						this.spellSel = 'spell';
						spellEnd = 1;
					}
				}
			} else if (this.lv == 6) {
				if (this.selected == 1) {
					if (this.spellSel == 'spell') {
						if (SeOn) { seSounded("SPELLRECITE"); }
						this.spellSel = 'mapMove';
						this.floor = this.party.floor;
						this.x = 0, this.y = 0;
						this.mapView(this.floor, this.x, this.y, 'map');
					} else {
						var ok = UseWarpSpell(this.floor, this.x, this.y);
						if (ok) {
							this.pc.mpM[this.lv]--;
							if (this.party.floor != this.floor) {
								this.party.floor = this.floor;
								gameMode.dungeonMode.roomCheck = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
							}
							this.party.x = this.x;
							this.party.y = this.y;
							KeyManager_removeListener(this);
							this.mode.onKeyPress('move');
							if (MusicOn) { musicStart("DUNGEON"); }
						} else {
							this.spellSel = 'spell';
							spellEnd = 2;
						}
					}
				}
			}
		} else if (this.kind == 1) {
			if (this.lv == 0) {
				if (this.selected == 0) {
					if (this.spellSel == 'spell') {
						this.spellSel = 'pc';
					} else {
						if (SeOn) { seSounded("SPELLRECITE"); }
						this.viewtext = this.recoverHp(this.pcNum, this.party.pc[this.targetPc], 0);
						spellEnd = 1;
					}
				} else if (this.selected == 1) {
					if (SeOn) { seSounded("SPELLRECITE"); }
					if (this.party.bright < 40) {
						this.party.bright = 40;
					}
					spellEnd = 1;
				}
			} else if (this.lv == 2) {
				if (this.selected == 0) {
					if (this.spellSel == 'spell') {
						this.spellSel = 'pc';
					} else {
						if (SeOn) { seSounded("SPELLRECITE"); }
						this.viewtext = this.recoverHp(this.pcNum, this.party.pc[this.targetPc], 1);
						spellEnd = 1;
					}
				} else if (this.selected == 1) {
					if (this.spellSel == 'spell') {
						this.spellSel = 'pc';
					} else {
						if (SeOn) { seSounded("SPELLRECITE"); }
						this.recoverStatus(this.pcNum, this.party.pc[this.targetPc], 0);
						spellEnd = 1;
					}
				} else if (this.selected == 2) {
					if (SeOn) { seSounded("SPELLRECITE"); }
					this.party.discrimination = 1;
					spellEnd = 1;
				}
			} else if (this.lv == 3) {
				if (this.selected == 0) {
					if (this.spellSel == 'spell') {
						this.spellSel = 'pc';
					} else {
						if (SeOn) { seSounded("SPELLRECITE"); }
						this.recoverStatus(this.pcNum, this.party.pc[this.targetPc], 1);
						spellEnd = 1;
					}
				} else if (this.selected == 1) {
					if (SeOn) { seSounded("SPELLRECITE"); }
					this.party.bright = 100;
					spellEnd = 1;
				}
			} else if (this.lv == 4) {
				if (this.selected == 0) {
					if (this.spellSel == 'spell') {
						this.spellSel = 'pc';
					} else {
						if (SeOn) { seSounded("SPELLRECITE"); }
						this.viewtext = this.recoverHp(this.pcNum, this.party.pc[this.targetPc], 2);
						spellEnd = 1;
					}
				} else if (this.selected == 1) {
					if (SeOn) { seSounded("SPELLRECITE"); }
					this.party.protection = 1;
					this.party.check();
					spellEnd = 1;
				}
			} else if (this.lv == 5) {
				if (this.selected == 0) {
					if (this.spellSel == 'spell') {
						this.spellSel = 'pc';
					} else {
						if (SeOn) { seSounded("SPELLRECITE"); }
						this.recoverHp(this.pcNum, this.party.pc[this.targetPc], 3);
						spellEnd = 1;
					}
				} else if (this.selected == 2) {
					if (SeOn) { seSounded("SPELLWARP"); }
					this.pc.mpP[this.lv]--;
					this.pc.pSpell[5][2] = 0;
					this.party.bright = 0;
					this.party.protection = 0;
					this.party.discrimination = 0;
					this.party.floor = 0;
					this.party.check();
					KeyManager_removeListener(this);
					KeyManager_removeListener(this.mode);
					gameMode.townMode.start();
					save(gameMode.pcModel, gameMode.partyModel);
				}
			} else if (this.lv == 6) {
				if (this.selected == 0) {
					if (SeOn) { seSounded("SPELLRECITE"); }
					this.viewtext = this.recoverHp(this.pcNum, 0, 4);
					this.partyStatus = 1;
					spellEnd = 1;
				} else if (this.selected == 2) {
					if (this.spellSel == 'spell') {
						this.spellSel = 'pc';
					} else {
						if (SeOn) { seSounded("SPELLRECITE"); }
						spellEnd = this.recoverStatus(this.pcNum, this.party.pc[this.targetPc], 2);
					}
				}
			}
		}
		if (spellEnd == 1) {
			this.spellEnd('I');
		} else if (spellEnd == 2) {
			this.spellEnd('sI');
		} else if (spellEnd == 3) {
			this.spellEnd('Ԃ');
		} else if (spellEnd == 4) {
			this.spellEnd('DɂȂ');
		} else if (spellEnd == 5) {
			this.spellEnd('ł');
		} else if (this.spellSel == 'pc') {
			this.targetPc = 0;
			this.pcSel();
		}
	} else if (this.stateMode == 'battle') {
		var sp = 800 + (this.kind * 100)+(this.lv * 10)+this.selected;
		this.pc.action[1] = sp;
		KeyManager_removeListener(this);
		if (sp == 900 || sp == 920 || sp == 921 || sp == 930 || sp == 940 || sp == 950) {
			this.mode.mode = 'pcSel';
			this.mode.update(0);
		} else if ((sp < 900 && sp != 802 && sp != 811 && sp != 812 && sp != 842 && sp != 860 && sp != 861 && sp != 862) || sp == 910 || sp == 911 || sp == 942 || sp == 951) {
			if (this.mode.nM[1].id == 0) {
				this.pc.action[2] = 0;
				this.mode.mode = 'actionSel';
				this.mode.nextPc(1);
				this.mode.update(0);
			} else {
				this.mode.mode = 'monsterSel';
				this.mode.update(0);
			}
		} else {
			this.mode.mode = 'actionSel';
			this.mode.nextPc(1);
			this.mode.update(0);
		}
	}
}

// ̕\
SelectionMode.prototype.spellEnd = function(text) {
	this.stop = 1;
	if (this.kind == 0) {
		this.pc.mpM[this.lv]--;
	} else {
		this.pc.mpP[this.lv]--;
	}
	this.fieldView.viewClear();
	this.textView.pcStatus(this.pcNum);
	this.textView.spellSelView(this.pcNum, this.stateMode, this.lv, this.kind, this.spellSel, this.selected);
	this.textView.alert(20, 8, 1, text);
	if (this.spellSel == 'pc') { this.pcSel(); }
	else if (this.partyStatus) {
		this.textView.partyStatus();
	}
	if (View && this.viewtext != '') {
		this.textView.message(16, 14, 'center', this.viewtext, 'left');
	}
	this.fieldView.update();
}

// pc̑I\
SelectionMode.prototype.pcSel = function() {
	if (!this.stop) { this.textView.alert(20, 12, 1, 'Nɂ܂H'); }
	this.textView.partyStatus();
	this.textView.textNonFrame(1, 1);
	this.textView.write(0, 0, '');
	this.textView.textSet(4, 6 - this.targetPc, 6 - this.targetPc);
	this.fieldView.update();
}

// Xe[^X
SelectionMode.prototype.recoverStatus = function(who, target, level) {
	var spellEnd = 1, state = this.pM[target].state;
	if (level == 0) {
		if (state == 1 || state == 2 || state == 3) {
			this.pM[target].state = 0;
			this.pM[target].sleep = 0;
		} else if (state == 11 || state == 12 || state == 13) {
			this.pM[target].state = 10;
			this.pM[target].sleep = 0;
		}
	} else if (level == 1) {
		if (state >= 10) {
			this.pM[target].state -= 10;
		}
	} else if (level == 2 && (state == 5 || state == 6)) {
		var lvBonus, r;
		lvBonus = Math.floor(this.pM[who].level / 2);
		if (lvBonus > 25) { lvBonus = 25; }
		else if (lvBonus < 0) { lvBonus = 0; }
		r = this.pM[target].abi[3] + this.pM[target].abi[5];
		r += this.pM[who].abi[2] + Math.floor(this.pM[who].abi[5] / 2);
		r += lvBonus;
		if (r > 90) { r = 90; }
		else if (r < 40) { r = 40; }
		if (View) { alert('F' + r + '%'); }
		if (state == 5) {
			if (dice(1, 100) <= r) {
				spellEnd = 3;
				this.pM[target].state = 0;
				this.pM[target].sleep = 0;
				this.pM[target].hpCtrl(9999);
				this.pM[target].ageWeek += 2;
			} else {
				spellEnd = 4;
				this.pM[target].state = 6;
			}
		} else if (state == 6) {
			if (dice(1, 100) <= r) {
				spellEnd = 3;
				this.pM[target].state = 0;
				this.pM[target].sleep = 0;
				this.pM[target].hpCtrl(9999);
				this.pM[target].ageWeek += 4;
			} else {
				spellEnd = 5;
				this.pM[target].state = 7;
			}
		}
	}
	this.pM[target].check(this.party.protection);
	return spellEnd;
}

// HP
SelectionMode.prototype.recoverHp = function(who, target, level) {
	var hp = 0, lvBonus, abiBonus = 1, classBonus;
	var reMin = 0, reMax = 0;

	if (this.pM[who].pcClass == 2) { classBonus = 5; }
	else if (this.pM[who].pcClass == 4) { classBonus = 6; }
	else if (this.pM[who].pcClass == 6) { classBonus = 7; }
	else { classBonus = 8; }
	lvBonus = Math.floor(this.pM[who].level / classBonus);
	if (this.pM[who].abi[2] >= 14) { abiBonus += 0.2; }
	if (this.pM[who].abi[2] >= 17) { abiBonus += 0.2; }
	if (this.pM[who].abi[2] >= 20) { abiBonus += 0.2; }

	var bonus = Math.floor(lvBonus * abiBonus);

	if (level == 0) {
		hp = dice(1, 8 + lvBonus) + bonus;
		this.pM[target].hpCtrl(hp);
		reMin = 1 + bonus, reMax = 1 * (8 + lvBonus) + bonus;
	} else if (level == 1) {
		hp = dice(2, 8 + lvBonus) + bonus;
		this.pM[target].hpCtrl(hp);
		reMin = 2 + bonus, reMax = 2 * (8 + lvBonus) + bonus;
	} else if (level == 2) {
		hp = dice(3, 8 + lvBonus) + bonus;
		this.pM[target].hpCtrl(hp);
		reMin = 3 + bonus, reMax = 3 * (8 + lvBonus) + bonus;
	} else if (level == 3) {
		if (this.pM[target].state != 5 && this.pM[target].state != 6 && this.pM[target].state != 7) {
			this.pM[target].state = 0;
			this.pM[target].sleep = 0;
			this.pM[target].check(this.party.protection);
		}
		this.pM[target].hpCtrl(9999);
	} else if (level == 4) {
		for (var i = 0; i < 6; i++) {
			if (this.party.pc[i] > 0) {
				hp = dice(5, 8 + lvBonus) + bonus;
				this.pM[this.party.pc[i]].hpCtrl(hp);
			} else { break; }
		}
		hp = 0;
		reMin = 5 + bonus, reMax = 5 * (8 + lvBonus) + bonus;
	}
	if (View && reMin > 0) {
		var viewtext = '';
		viewtext = '񕜕F' + hzNum(reMin, 0) + '`';
		viewtext += hzNum(reMax, 0);
		if (hp > 0) { viewtext += '\n񕜒lF' + hzNum(hp, 0); }
		return viewtext;
	}
}

// L[ꂽƂ
SelectionMode.prototype.onKeyPress = function(key) {

	if (key == 'r' || key == 'R') {
		Reset = 1;
		gameMode.init(true);
		return;
	}

	if (this.stop) {
		if (this.selMode == 10 && (this.spellSel == 'mapView' || this.spellSel == 'mapPc')) {
			this.magic();
			return;
		} else if (this.selMode == 10) {
			this.stop = 0;
			this.fieldView.viewClear();
			this.textView.pcStatus(this.pcNum);
			if (this.kind == 0) {
				if (this.pc.mpM[this.lv] == 0) {
					this.spellSel = 'level';
				}
			} else if (this.kind == 1) {
				if (this.pc.mpP[this.lv] == 0) {
					this.spellSel = 'level';
				}
			}
			this.textView.spellSelView(this.pcNum, this.stateMode, this.lv, this.kind, this.spellSel, this.selected);
			if (this.spellSel == 'pc') { this.pcSel(); }
			else if (this.partyStatus) { this.partyStatus = 0; }
			this.fieldView.update();
			return;
		}
	}

	var update = 0;
	if (key == '8' || key == 'u' || key == 'U') {
		if (this.selMode == 10) {
			if (this.spellSel == 'level') {
				if(this.kind) { this.kind = 0; }
				else { this.kind = 1; }
				if (this.lv >= 7) { this.lv = 0; }
				this.spellList = this.textView.spellSelView(this.pcNum, this.stateMode, this.lv, this.kind, this.spellSel, this.selected);
				this.fieldView.update();
			} else if (this.spellSel == 'spell') {
				if (this.spellList[0] + this.spellList[1] + this.spellList[2] > 0) {
					var sel = this.selected;
					sel--;
					if (sel < 0) { sel = 2; }
					if (this.spellList[sel]) {
						this.selected = sel;
					} else {
						sel--;
						if (sel < 0) { sel = 2; }
						if (this.spellList[sel]) {
							this.selected = sel;
						}
					}
				} else { this.selected = -1; }
				this.spellList = this.textView.spellSelView(this.pcNum, this.stateMode, this.lv, this.kind, this.spellSel, this.selected);
				this.fieldView.update();
			} else if (this.spellSel == 'pc') {
				this.targetPc--;
				if (this.targetPc < 0) {
					for (var i = 5; i >= 0; i--) {
						if (this.party.pc[i] > 0) {
							this.targetPc = i;
							break;
						}
					}
				}
				this.pcSel();
			} else if (this.spellSel == 'mapMove') {
				this.floor++;
				if (this.floor >= 0) {
					this.floor = FLOOR_MAX * -1;
				}
				this.mapView(this.floor, this.x, this.y, 'map');
			} else if (this.spellSel == 'mapMove_1') {
				this.y++;
				if (this.y >= MAP_SIZE_Y) { this.y = 0; }
				this.mapView_2(this.x, this.y);
			} else if (this.spellSel == 'mapPc') {
				this.searchPc--;
				this.mapPc_2();
			}
		} else {
			this.selected--;
			while(true) {
				if (this.selected < 0) {
					this.selected = this.choice.length - 1;
				}
				if (this.choice[this.selected] == '' || this.choice[this.selected] == 0) {
					this.selected--;
				} else { break; }
			}
			update = 1;
		}
	} else if (key == '4' || key == 'h' || key == 'H') {
		if (this.selMode == 10) {
			if (this.spellSel == 'level' || this.spellSel == 'spell') {
				this.lv--;
				if (this.lv < 0) { this.lv = 6; }
				this.spellList = this.textView.spellSelView(this.pcNum, this.stateMode, this.lv, this.kind, this.spellSel, this.selected);
				if (this.spellSel == 'spell') {
					if (this.spellList[0] + this.spellList[1] + this.spellList[2] > 0) {
						for (var i = 0; i < this.spellList.length; i++) {
							if (this.spellList[i]) {
								this.selected = i;
								break;
							}
						}
					} else { this.selected = -1; }
				}
				this.textView.spellSelView(this.pcNum, this.stateMode, this.lv, this.kind, this.spellSel, this.selected);
				this.fieldView.update();
			} else if (this.spellSel == 'mapMove_1') {
				this.x--;
				if (this.x < 0) { this.x = MAP_SIZE_X - 1; }
				this.mapView_2(this.x, this.y);
			} else if (this.spellSel == 'mapPc') {
				this.searchPc -= 6;
				if (this.searchPc < 0) { this.searchPc = 0; }
				this.mapPc_2();
			}
		} else {
			KeyManager_removeListener(this);
			this.mode.leftEnter(this.selected);
		}
	} else if (key == '6' || key == 'k' || key == 'K') {
		if (this.selMode == 10) {
			if (this.spellSel == 'level' || this.spellSel == 'spell') {
				this.lv++;
				if (this.lv >= 7) { this.lv = 0; }
				this.spellList = this.textView.spellSelView(this.pcNum, this.stateMode, this.lv, this.kind, this.spellSel, this.selected);
				if (this.spellSel == 'spell') {
					if (this.spellList[0] + this.spellList[1] + this.spellList[2] > 0) {
						for (var i = 0; i < this.spellList.length; i++) {
							if (this.spellList[i]) {
								this.selected = i;
								break;
							}
						}
					} else { this.selected = -1; }
				}
				this.textView.spellSelView(this.pcNum, this.stateMode, this.lv, this.kind, this.spellSel, this.selected);
				this.fieldView.update();
			} else if (this.spellSel == 'mapMove_1') {
				this.x++;
				if (this.x >= MAP_SIZE_X) { this.x = 0; }
				this.mapView_2(this.x, this.y);
			} else if (this.spellSel == 'mapPc') {
				this.searchPc += 6;
				var i, tmp;
				for (i = this.pM.length - 1; i >= 1; i--) {
					if (this.pM[i].name != '') {
						tmp = i;
						break;
					}
				}
				if (this.searchPc >= tmp) {
					this.searchPc = tmp-1;
				}
				this.mapPc_2();
			}
		} else {
			KeyManager_removeListener(this);
			this.mode.rightEnter(this.selected);
		}
	} else if (key == '2' || key == 'n' || key == 'N') {
		if (this.selMode == 10) {
			if (this.spellSel == 'level') {
				if(this.kind) { this.kind = 0; }
				else { this.kind = 1; }
				if (this.lv >= 7) { this.lv = 0; }
				this.spellList = this.textView.spellSelView(this.pcNum, this.stateMode, this.lv, this.kind, this.spellSel, this.selected);
				this.fieldView.update();
			} else if (this.spellSel == 'spell') {
				if (this.spellList[0] + this.spellList[1] + this.spellList[2] > 0) {
					var sel = this.selected;
					sel++;
					if (sel > 2) { sel = 0; }
					if (this.spellList[sel]) {
						this.selected = sel;
					} else {
						sel++;
						if (sel > 2) { sel = 0; }
						if (this.spellList[sel]) {
							this.selected = sel;
						}
					}
				} else { this.selected = -1; }
				this.spellList = this.textView.spellSelView(this.pcNum, this.stateMode, this.lv, this.kind, this.spellSel, this.selected);
				this.fieldView.update();
			} else if (this.spellSel == 'pc') {
				this.targetPc++;
				if (this.targetPc > 5) {
					this.targetPc = 0;
				} else if (this.party.pc[this.targetPc] == 0) {
					this.targetPc = 0;
				}
				this.pcSel();
			} else if (this.spellSel == 'mapMove') {
				this.floor--;
				if (this.floor < FLOOR_MAX * -1) {
					this.floor = -1;
				}
				this.mapView(this.floor, this.x, this.y, 'map');
			} else if (this.spellSel == 'mapMove_1') {
				this.y--;
				if (this.y < 0) { this.y = MAP_SIZE_Y - 1; }
				this.mapView_2(this.x, this.y);
			} else if (this.spellSel == 'mapPc') {
				this.searchPc++;
				this.mapPc_2();
			}
		} else {
			this.selected++;
			while(true) {
				if (this.selected >= this.choice.length) {
					this.selected = 0;
				}
				if (this.choice[this.selected] == '' || this.choice[this.selected] == 0) {
					this.selected++;
				} else { break; }
			}
			update = 1;
		}
	} else if (key == '5' || key == 'z' || key == 'Z') {
		if (this.selMode == 10) {
			if (this.spellSel == 'level') {
				if (this.spellList[0] + this.spellList[1] + this.spellList[2] > 0) {
					if (this.kind == 0) {
						if (this.pc.mpM[this.lv] > 0) {
							this.spellSel = 'spell';
						}
					} else if (this.kind == 1) {
						if (this.pc.mpP[this.lv] > 0) {
							this.spellSel = 'spell';
						}
					}
					if (this.spellSel == 'spell') {
						for (var i = 0; i < this.spellList.length; i++) {
							if (this.spellList[i]) {
								this.selected = i;
								break;
							}
						}
					}
				}
				this.textView.spellSelView(this.pcNum, this.stateMode, this.lv, this.kind, this.spellSel, this.selected);
				this.fieldView.update();
			} else if ((this.spellSel == 'spell' && this.selected >= 0) || this.spellSel == 'pc' || this.spellSel == 'mapMove_1') {
				if (this.spellSel == 'spell') {
					this.oops = 1;
				} else if (this.spellSel == 'pc') {
					this.oops = 0;
				}
				this.magic();
			} else if (this.spellSel == 'mapMove') {
				this.spellSel = 'mapMove_1';
				this.mapView(this.floor, this.x, this.y, 'none');
			} else if (this.spellSel == 'mapPc') {
				this.mapPcEnter(this.searchPc + 1);
			}
		} else {
			KeyManager_removeListener(this);
			this.mode.enter(this.selected);
		}
	} else if (key == '0' || key == 'x' || key == 'X') {
		if (this.selMode == 10) {
			if (this.spellSel == 'spell') {
				this.spellSel = 'level';
				this.textView.spellSelView(this.pcNum, this.stateMode, this.lv, this.kind, this.spellSel, this.selected);
				this.fieldView.update();
			} else if (this.spellSel == 'pc' || this.spellSel == 'mapMove' || this.spellSel == 'mapPc') {
				this.spellSel = 'spell';
				this.fieldView.viewClear();
				this.textView.pcStatus(this.pcNum);
				this.textView.spellSelView(this.pcNum, this.stateMode, this.lv, this.kind, this.spellSel, this.selected);
				if (this.oops) {
					this.stop = 1;
					this.textView.alert(20, 6, 1, 'ƁIH');
				}
				this.fieldView.update();
			} else if (this.spellSel == 'mapMove_1') {
				this.spellSel = 'mapMove';
				this.mapView(this.floor, this.x, this.y, 'map');
			} else {
				KeyManager_removeListener(this);
				this.mode.cancel(this.selected);
			}
		} else {
			KeyManager_removeListener(this);
			this.mode.cancel(this.selected);
		}
	}

	if (update) {
		if (this.selMode == 0) { this.choiceSet(); }
		else if (this.selMode == 1) { this.choiceSetNon(); }
		else if (this.selMode == 2) { this.choiceSetNonD(); }
		this.fieldView.update();
	}
}

