// eLXg̃Zbg

// eLXgr[NX
function TextView(sizeX, sizeY, fieldView, partyModel, pcModel) {
	this.sizeX = sizeX;
	this.sizeY = sizeY;
	this.fieldView = fieldView;
	this.partyModel = partyModel;
	this.pcModel = pcModel;
	this.lineData;
}

// xbZ[W
TextView.prototype.alert = function(position, width, height, text) {
	var viewYMax = position + 3, viewYMin = position - 3;
	if(this.textFrame(width + 6, height + 6) && viewYMax <= this.sizeY && viewYMin >= 0 && text.length <= width) {
		var alignX = Math.floor((width + 6) / 2 - text.length / 2);
		this.lineData[3] = strReplace(this.lineData[3], alignX, text);
		this.textSet('center', viewYMax, viewYMin);
	}
}

// bZ[W̏
TextView.prototype.write = function(x, y, text) {
	this.lineData[y] = strReplace(this.lineData[y], x, text);
}

// ^CgbZ[W
TextView.prototype.titleMessage = function(position, text) {
	var viewYMax = position + 1, viewYMin = position - 1;
	if(this.textFrameNonMargin(text.length + 2, 3) && viewYMax <= this.sizeY && viewYMin >= 0) {
		var alignX = Math.floor((text.length + 2) / 2 - text.length / 2);
		this.lineData[1] = strReplace(this.lineData[1], alignX, text);
		this.textSet('center', viewYMax, viewYMin);
	}
}

// bZ[W
TextView.prototype.message = function(position, width, align, text, textAlign) {
	var spText = text.split('\n');
	var length = 0;
	var i;
	for (i = 0; i < spText.length; i++) {
		if (spText[i].length > length) { length = spText[i].length; }
	}
	if (width > length) {
		length = width;
	}

	this.textFrame(length + 6, spText.length + 6);
	var j = 2 + spText.length, k;
	for (i = 0; i < spText.length; i++) {
		if (textAlign == 'center') {
			k = Math.floor((length + 6) / 2 - spText[i].length / 2);
		} else if (textAlign == 'right') {
			k = length + 3 - spText[i].length;
		} else { k = 3; }
		this.lineData[j] = strReplace(this.lineData[j], k, spText[i]);
		j--;
	}
	this.textSet(align, position, position - spText.length - 5);
}

// bZ[Wi]Ȃj
TextView.prototype.messageNonMargin = function(position, align, text) {
	var spText = text.split('\n');
	var length = 0;
	var i;
	for (i = 0; i < spText.length; i++) {
		if (spText[i].length > length) { length = spText[i].length; }
	}

	this.textFrame(length + 4, spText.length + 4);
	var j = 1 + spText.length;
	for (i = 0; i < spText.length; i++) {
		this.lineData[j] = strReplace(this.lineData[j], 2, spText[i]);
		j--;
	}
	this.textSet(align, position, position - spText.length - 3);
}

// ̑I\
TextView.prototype.spellSelView = function(pcNum, mode, lv, kind, selMode, sel) {
	var i, text, pc = this.pcModel[pcNum];
	text = 'lF@';
	if (lv == 0 && kind == 0) {
		text += '';
	} else { text += '@'; }
	text += hzNum(pc.mpM[0], 1);
	for (i = 1; i < pc.mpM.length; i++) {
		text += '^@';
		if (lv == i && kind == 0) {
			text += '';
		} else { text += '@'; }
		text += hzNum(pc.mpM[i], 1);
	}
	text += '\noF@';
	if (lv == 0 && kind == 1) {
		text += '';
	} else { text += '@'; }
	text += hzNum(pc.mpP[0], 1);
	for (i = 1; i < pc.mpP.length; i++) {
		text += '^@';
		if (lv == i && kind == 1) {
			text += '';
		} else { text += '@'; }
		text += hzNum(pc.mpP[i], 1);
	}
	this.messageNonMargin(20, 'center', text);
	var spList = new Array(0,0,0);
	if (mode == 'camp') {
		if (kind == 0) {
			if (lv == 0 || lv == 1) {
				text = '@@@@\n\n';
				if (pc.mSpell[lv][2] == 1) {
					spList[2] = 1;
					if (selMode != 'level' && kind == 0 && sel == 2) {
						text += '';
					} else { text += '@'; }
					text += '@' + MAGE_SPELL[lv][2];
				}
			} else if (lv == 6) {
				text = '@@@@\n';
				if (pc.mSpell[lv][1] == 1) {
					spList[1] = 1;
					if (selMode != 'level' && kind == 0 && sel == 1) {
						text += '';
					} else { text += '@'; }
					text += '@' + MAGE_SPELL[lv][1] + '\n';
				} else { text += '@@@@\n'; }
			} else { text = '@@@@\n\n'; }
		} else if (kind == 1) {
			if (lv == 0 || lv == 3 || lv == 4) {
				if (pc.pSpell[lv][0] == 1) {
					spList[0] = 1;
					if (selMode != 'level' && kind == 1 && sel == 0) {
						text = '';
					} else { text = '@'; }
					text += '@'+ PRIEST_SPELL[lv][0] + '\n';
				} else { text = '@@@@\n'; }
				if (pc.pSpell[lv][1] == 1) {
					spList[1] = 1;
					if (selMode != 'level' && kind == 1 && sel == 1) {
						text += '';
					} else { text += '@'; }
					text += '@'+ PRIEST_SPELL[lv][1] + '\n';
				} else { text += '@@@@\n'; }
			} else if (lv == 2) {
				if (pc.pSpell[lv][0] == 1) {
					spList[0] = 1;
					if (selMode != 'level' && kind == 1 && sel == 0) {
						text = '';
					} else { text = '@'; }
					text += '@'+ PRIEST_SPELL[lv][0] + '\n';
				} else { text = '@@@@\n'; }
				if (pc.pSpell[lv][1] == 1) {
					spList[1] = 1;
					if (selMode != 'level' && kind == 1 && sel == 1) {
						text += '';
					} else { text += '@'; }
					text += '@'+ PRIEST_SPELL[lv][1] + '\n';
				} else { text += '@@@@\n'; }
				if (pc.pSpell[lv][2] == 1) {
					spList[2] = 1;
					if (selMode != 'level' && kind == 1 && sel == 2) {
						text += '';
					} else { text += '@'; }
					text += '@' + PRIEST_SPELL[lv][2];
				}
			} else if (lv == 5 || lv == 6) {
				if (pc.pSpell[lv][0] == 1) {
					spList[0] = 1;
					if (selMode != 'level' && kind == 1 && sel == 0) {
						text = '';
					} else { text = '@'; }
					text += '@'+ PRIEST_SPELL[lv][0] + '\n';
				} else { text = '@@@@\n'; }
				text += '@@@@\n';
				if (pc.pSpell[lv][2] == 1) {
					spList[2] = 1;
					if (selMode != 'level' && kind == 1 && sel == 2) {
						text += '';
					} else { text += '@'; }
					text += '@'+ PRIEST_SPELL[lv][2];
				}
			} else { text = '@@@@\n\n'; }
		}
	} else if (mode == 'battle') {
		if (kind == 0) {
			if (lv == 0 || lv == 1) {
				if (pc.mSpell[lv][0] == 1) {
					spList[0] = 1;
					if (selMode != 'level' && kind == 0 && sel == 0) {
						text = '';
					} else { text = '@'; }
					text += '@' + MAGE_SPELL[lv][0] + '\n';
				} else { text = '@@@@\n'; }
				if (pc.mSpell[lv][1] == 1) {
					spList[1] = 1;
					if (selMode != 'level' && kind == 0 && sel == 1) {
						text += '';
					} else { text += '@'; }
					text += '@' + MAGE_SPELL[lv][1] + '\n';
				} else { text += '@@@@\n'; }
			} else if (lv >= 2) {
				if (pc.mSpell[lv][0] == 1) {
					spList[0] = 1;
					if (selMode != 'level' && kind == 0 && sel == 0) {
						text = '';
					} else { text = '@'; }
					text += '@' + MAGE_SPELL[lv][0] + '\n';
				} else { text = '@@@@\n'; }
				if (pc.mSpell[lv][1] == 1) {
					spList[1] = 1;
					if (selMode != 'level' && kind == 0 && sel == 1) {
						text += '';
					} else { text += '@'; }
					text += '@' + MAGE_SPELL[lv][1] + '\n';
				} else { text += '@@@@\n'; }
				if (pc.mSpell[lv][2] == 1) {
					spList[2] = 1;
					if (selMode != 'level' && kind == 0 && sel == 2) {
						text += '';
					} else { text += '@'; }
					text += '@' + MAGE_SPELL[lv][2];
				}
			}
		} else if (kind == 1) {
			if (lv == 1 || lv == 6) {
				if (pc.pSpell[lv][0] == 1) {
					spList[0] = 1;
					if (selMode != 'level' && kind == 1 && sel == 0) {
						text = '';
					} else { text = '@'; }
					text += '@'+ PRIEST_SPELL[lv][0] + '\n';
				} else { text = '@@@@\n'; }
				if (pc.pSpell[lv][1] == 1) {
					spList[1] = 1;
					if (selMode != 'level' && kind == 1 && sel == 1) {
						text += '';
					} else { text += '@'; }
					text += '@'+ PRIEST_SPELL[lv][1] + '\n';
				} else { text += '@@@@\n'; }
			} else {
				if (pc.pSpell[lv][0] == 1) {
					spList[0] = 1;
					if (selMode != 'level' && kind == 1 && sel == 0) {
						text = '';
					} else { text = '@'; }
					text += '@'+ PRIEST_SPELL[lv][0] + '\n';
				} else { text = '@@@@\n'; }
				if (pc.pSpell[lv][1] == 1) {
					spList[1] = 1;
					if (selMode != 'level' && kind == 1 && sel == 1) {
						text += '';
					} else { text += '@'; }
					text += '@'+ PRIEST_SPELL[lv][1] + '\n';
				} else { text += '@@@@\n'; }
				if (pc.pSpell[lv][2] == 1) {
					spList[2] = 1;
					if (selMode != 'level' && kind == 1 && sel == 2) {
						text += '';
					} else { text += '@'; }
					text += '@'+ PRIEST_SPELL[lv][2];
				}
			}
		}
	}
	this.messageNonMargin(15, 5, text);
	return spList;
}

// pc̃Xe[^X
TextView.prototype.pcStatus = function(num) {
	this.fieldView.viewClear();
	this.textFrameNonMargin(42, 38);
	var i, y = 35, pc = this.pcModel[num], str;
	if (pc.title == 1) { str = '@'; }
	else if (pc.title == 2) { str = '@'; }
	else { str = '@@'; }
	str += pc.name;
	for (i = pc.name.length; i < 16; i++) { str += '@'; }
	str += 'k';
	str += hzNum(pc.level, 0);
	if (pc.level < 10) { str += '@@@@'; }
	else if (pc.level < 100) { str += '@@@'; }
	else if (pc.level < 1000) { str += '@@'; }
	else { str += '@'; }
	str += '@@@@' + abbreviation('race', pc.race);
	str += '|' + abbreviation('alignment', pc.alignment);
	str += '|' + abbreviation('pcClass', pc.pcClass);
	this.write(2, y, str), y -= 2;

	str = 'go@' + hzNum(pc.hp, 4) + '^' + hzNum(pc.hpMax, 4);
	str += '@@' + abbreviation('state', pc.state);
	this.write(17, y, str), y--;

	str = 'rsqF' + hzNum(pc.abi[0], 2) + '@@@';
	str += 'dwo@@F' + hzNum(pc.exp, 12) + '@@';
	str += '`fdF' + hzNum(pc.age, 3);
	this.write(2, y, str), y--;

	str = '@hpF' + hzNum(pc.abi[1], 2) + '@@@';
	str += 'mdws@F' + hzNum(pc.next, 12) + '@@';
	str += '`b@F';
	if (pc.ac < -99) { str += '|' + hzNum(99, 2); }
	else if (pc.ac < -9) { str += '|' + hzNum(pc.ac * -1, 2); }
	else if (pc.ac < 0) { str += '@|' + hzNum(pc.ac * -1, 1); }
	else if (pc.ac > 99) { str += hzNum(99, 3); }
	else { str += hzNum(pc.ac, 3); }
	this.write(2, y, str), y--;

	str = 'ohdF' + hzNum(pc.abi[2], 2) + '@@@';
	str += 'fnkc@F' + hzNum(pc.gold, 12);
	this.write(2, y, str), y--;

	str = 'uhsF' + hzNum(pc.abi[3], 2) + '@@@';
	this.write(2, y, str), y--;

	str = '`fhF' + hzNum(pc.abi[4], 2) + '@@@';
	str += '@@lF@' + hzNum(pc.mpM[0], 1);
	for (i = 1; i < pc.mpM.length; i++) {
		str += '^' + hzNum(pc.mpM[i], 1);
	}
	this.write(2, y, str), y--;

	str = 'ktjF' + hzNum(pc.abi[5], 2) + '@@@';
	str += '@@oF@' + hzNum(pc.mpP[0], 1);
	for (i = 1; i < pc.mpP.length; i++) {
		str += '^' + hzNum(pc.mpP[i], 1);
	}
	this.write(2, y, str), y -= 2;

	for (i = 0; i < pc.item.length; i++) {
		if (pc.item[i] > 0) {
			str = itemStr(pc.item[i], pc.itemS[i], pc.alignment, pc.pcClass);
			this.write(3, y, str);
		}
		y--;
	}
	y--;

	str = 'yl@rz';
	this.write(2, y, str), y--;
	str = 'kP@@kQ@@kR@@kS@@kT@@kU@@kV';
	this.write(4, y, str), y--;
	str = '';
	for (i = 0; i < pc.mpM.length; i++) {
		str += '@@' + hzNum(pc.mpM[i], 1) + '^';
		str += hzNum(pc.mpMMax[i], 1);
	}
	this.write(3, y, str), y -= 2;

	str = '';
	for (i = 0; i < pc.mSpell.length; i++) {
		if (pc.mSpell[i][0] == 1) {
			str += MAGE_SPELL[i][0] + '@@@';
		} else { str += '' + '@@@'; }
	}
	this.write(5, y, str), y--;
	str = '';
	for (i = 0; i < pc.mSpell.length; i++) {
		if (pc.mSpell[i][1] == 1) {
			str += MAGE_SPELL[i][1] + '@@@';
		} else { str += '' + '@@@'; }
	}
	this.write(5, y, str), y--;
	str = '';
	for (i = 0; i < pc.mSpell.length; i++) {
		if (pc.mSpell[i][2] == 1) {
			str += MAGE_SPELL[i][2] + '@@@';
		} else { str += '' + '@@@'; }
	}
	this.write(5, y, str), y--;

	y--;

	str = 'yo@rz';
	this.write(2, y, str), y--;
	str = 'kP@@kQ@@kR@@kS@@kT@@kU@@kV';
	this.write(4, y, str), y--;
	str = '';
	for (i = 0; i < pc.mpP.length; i++) {
		str += '@@' + hzNum(pc.mpP[i], 1) + '^';
		str += hzNum(pc.mpPMax[i], 1);
	}
	this.write(3, y, str), y -= 2;

	str = '';
	for (i = 0; i < pc.pSpell.length; i++) {
		if (pc.pSpell[i][0] == 1) {
			str += PRIEST_SPELL[i][0] + '@@@';
		} else { str += '' + '@@@'; }
	}
	this.write(5, y, str), y--;
	str = '';
	for (i = 0; i < pc.pSpell.length; i++) {
		if (pc.pSpell[i][1] == 1) {
			str += PRIEST_SPELL[i][1] + '@@@';
		} else { str += '' + '@@@'; }
	}
	this.write(5, y, str), y--;
	str = '';
	for (i = 0; i < pc.pSpell.length; i++) {
		if (pc.pSpell[i][2] == 1) {
			str += PRIEST_SPELL[i][2] + '@@@';
		} else { str += '' + '@@@'; }
	}
	this.write(5, y, str), y--;

	if (View) {
		var dmgBonus = 0;
		y = 25;
		if (pc.pcClass == 0 || pc.pcClass == 5 || pc.pcClass == 6 || pc.pcClass == 7) {
			for (i = 16; i <= pc.abi[0]; i++) { dmgBonus++; }
		}
		str = '@_[WF';
		i = pc.dmgDiceNum + pc.dmgDicePlus + dmgBonus;
		str += hzNum(i, 0) + '`';
		i = (pc.dmgDiceNum * pc.dmgDice) + pc.dmgDicePlus + dmgBonus;
		str += hzNum(i, 0);
		if (pc.crit) { str += '@'; }
		this.write(12, y, str), y--;
		str = '@rsF' + hzNum(pc.st, 2);
		str += '@`sF' + hzNum(pc.at, 2);
		this.write(12, y, str), y--;
		str = '@tF';
		if (pc.hpPlus != 0) {
			if (pc.hpPlus < 0) { str += '|', i = pc.hpPlus * -1; }
			else { i = pc.hpPlus; }
			str += '' + hzNum(i, 0) + '@';
		}
		if (pc.noSpell > 0) {
			str += '' + hzNum(pc.noSpell, 0) + '';
		}
		this.write(12, y, str), y--;
		str = '@RF';
		if (pc.resist[0]) { str += ''; } else { str += '@'; }
		if (pc.resist[1]) { str += ''; } else { str += '@'; }
		if (pc.resist[2]) { str += 'd'; } else { str += '@'; }
		if (pc.resist[3]) { str += ''; } else { str += '@'; }
		this.write(12, y, str), y--;
		str = '@RF';
		if (pc.resist[4]) { str += ''; } else { str += '@'; }
		if (pc.resist[5]) { str += ''; } else { str += '@'; }
		if (pc.resist[6]) { str += ''; } else { str += '@'; }
		if (pc.resist[7]) { str += ''; } else { str += '@'; }
		if (pc.resist[8]) { str += ''; } else { str += '@'; }
		if (pc.resist[9]) { str += 'z'; } else { str += '@'; }
		if (pc.resist[10]) { str += ''; } else { str += '@'; }
		this.write(12, y, str);
		str = '@{ŁF';
		if (pc.doubleAt[0]) { str += ''; } else { str += '@'; }
		if (pc.doubleAt[1]) { str += ''; } else { str += '@'; }
		if (pc.doubleAt[2]) { str += 'm'; } else { str += '@'; }
		if (pc.doubleAt[3]) { str += ''; } else { str += '@'; }
		if (pc.doubleAt[4]) { str += ''; } else { str += '@'; }
		if (pc.doubleAt[5]) { str += '_'; } else { str += '@'; }
		if (pc.doubleAt[6]) { str += ''; } else { str += '@'; }
		if (pc.doubleAt[7]) { str += ''; } else { str += '@'; }
		if (pc.doubleAt[8]) { str += 'b'; } else { str += '@'; }
		if (pc.doubleAt[9]) { str += 's'; } else { str += '@'; }
		if (pc.doubleAt[10]) { str += ''; } else { str += '@'; }
		if (pc.doubleAt[11]) { str += ''; } else { str += '@'; }
		if (pc.doubleAt[12]) { str += ''; } else { str += '@'; }
		this.write(14, 17, str);
		str = '@hF';
		if (pc.atDef[0]) { str += ''; } else { str += '@'; }
		if (pc.atDef[1]) { str += ''; } else { str += '@'; }
		if (pc.atDef[2]) { str += 'm'; } else { str += '@'; }
		if (pc.atDef[3]) { str += ''; } else { str += '@'; }
		if (pc.atDef[4]) { str += ''; } else { str += '@'; }
		if (pc.atDef[5]) { str += '_'; } else { str += '@'; }
		if (pc.atDef[6]) { str += ''; } else { str += '@'; }
		if (pc.atDef[7]) { str += ''; } else { str += '@'; }
		if (pc.atDef[8]) { str += 'b'; } else { str += '@'; }
		if (pc.atDef[9]) { str += 's'; } else { str += '@'; }
		if (pc.atDef[10]) { str += ''; } else { str += '@'; }
		if (pc.atDef[11]) { str += ''; } else { str += '@'; }
		if (pc.atDef[12]) { str += ''; } else { str += '@'; }
		this.write(14, 16, str), y--;
	}

	this.textSet('center', 38, 1);
}

// p[eB[S̃Xe[^X
TextView.prototype.partyStatus = function() {
	this.textFrameNonMargin(38, 9);
	this.write(3, 8, 'mb`bgo^r');

	if (Party >= 0) {
		var party = this.partyModel, pc = this.pcModel, ppc;
		var name, i, j, y = 6;
		for (i = 0; i < party[Party].pc.length; i++) {
			if (party[Party].pc[i] == 0) { break; }
			ppc = pc[party[Party].pc[i]];
			name = ppc.name;
			for (j = name.length; j < 9; j++) { name += '@'; }
			name += abbreviation('race', ppc.race);
			name += '|' + abbreviation('alignment', ppc.alignment);
			name += '|' + abbreviation('pcClass', ppc.pcClass);
			name += '@';
			if (ppc.ac < -19) {
				name += 'uk';
			} else if (ppc.ac < -9) {
				name += 'kn';
			} else if (ppc.ac < 0) {
				name += '|' + hzNum(ppc.ac * -1, 1);
			} else if (ppc.ac > 99) {
				name += 'XX';
			} else { name += hzNum(ppc.ac, 2); }
			if (ppc.hpPlus > 0) {
				name += '{@';
			} else if (ppc.hpPlus < 0) {
				name += '|@';
			} else { name += '@@'; }
			name += hzNum(ppc.hp, 4) + '^';
			if (ppc.state != 0 || ppc.silent) {
				if (ppc.state != 0) {
					name += '@' + abbreviation('state', ppc.state);
				}
				if (ppc.silent) {
					name += '@';
				}
			} else { name += hzNum(ppc.hpMax, 4) }
			for (j = name.length; j < 33; j++) { name += '@'; }
			if (ppc.next == 0) { name += ''; }
			this.write(3, y, name);
			y--;
		}
	}
	this.textSet('center', 8, 0);
}

// eLXg\g
TextView.prototype.textFrame = function(width, height) {
	this.lineData = new Array(height);
	if (height > this.sizeY || width > this.sizeX) {
		return false;
	}

	var i, j;
	for (j = height - 1; j >= 0; j--) {
		if (j == height - 1 || j == 0) {
			this.lineData[j] = '@@';
		}
		else if (j == height - 2) { this.lineData[j] = '@'; }
		else if (j == 1) { this.lineData[j] = '@'; }
		else { this.lineData[j] = '@'; }
	}
	for (j = height - 1; j >= 0; j--) {
		for (var i = 2; i < width - 2; i++) {
			if (j == height - 2 || j == 1) {
				this.lineData[j] += '';
			} else {
				this.lineData[j] += '@';
			}
		}
	}
	for (j = height - 1; j >= 0; j--) {
		if (j == height - 1 || j == 0) {
			this.lineData[j] += '@@';
		}
		else if (j == height - 2) { this.lineData[j] += '@'; }
		else if (j == 1) { this.lineData[j] += '@'; }
		else { this.lineData[j] += '@'; }
	}

	return true;
}

// eLXg\gi]Ȃj
TextView.prototype.textFrameNonMargin = function(width, height) {
	this.lineData = new Array(height);
	if (height > this.sizeY || width > this.sizeX) {
		return false;
	}

	var i, j;
	for (j = height - 1; j >= 0; j--) {
		if (j == height - 1) { this.lineData[j] = ''; }
		else if (j == 0) { this.lineData[j] = ''; }
		else { this.lineData[j] = ''; }
	}
	for (j = height - 1; j >= 0; j--) {
		for (var i = 1; i < width - 1; i++) {
			if (j == height - 1 || j == 0) {
				this.lineData[j] += '';
			} else {
				this.lineData[j] += '@';
			}
		}
	}
	for (j = height - 1; j >= 0; j--) {
		if (j == height - 1) { this.lineData[j] += ''; }
		else if (j == 0) { this.lineData[j] += ''; }
		else { this.lineData[j] += ''; }
	}

	return true;
}

// eLXg\gȂ
TextView.prototype.textNonFrame = function(width, height) {
	this.lineData = new Array(height);
	var i, j;
	for (j = 0; j < height; j++) {
		this.lineData[j] = '@';
		for (i = 1; i < width; i++) {
			this.lineData[j] += '@';
		}
	}
}

// ʕ\f[^ɃZbg
TextView.prototype.textSet = function(align, yMax, yMin) {
	var lineLength = this.lineData[0].length;
	var alignX;
	if (align == 'left') {
		alignX = 0;
	} else if (align == 'right') {
		alignX = this.sizeX - lineLength;
	} else if (align == 'center') {
		alignX = Math.floor(this.sizeX / 2 - lineLength / 2);
	} else { alignX = align; }
	var j = this.lineData.length;
	for (var i = yMax; i >= yMin; i--) {
		j--;
		this.fieldView.viewData[i] = strReplace(this.fieldView.viewData[i], alignX, this.lineData[j]);
	}
}

