// p[eB[̃f[^ێ

// p[eB[fNX
function PartyModel(id, partyModel, pcModel) {
	this.id = id;
	this.partyModel = partyModel;
	this.pcModel = pcModel;
	this.init();
}

// pc̉
PartyModel.prototype.pcAdd = function(num) {
	for (var i = 0; i < this.pc.length; i++) {
		if (this.pc[i] == 0) {
			this.pc[i] = num;
			this.pcModel[num].party = this.id;
			break;
		}
	}
}

// pc̗E
PartyModel.prototype.pcDelete = function(num) {
	var i, hit = -1;
	for (i = 0; i < this.pc.length; i++) {
		if (this.pc[i] == num) {
			hit = i;
			this.pcModel[num].party = -1;
			break;
		}
	}
	if (hit >= 0) {
		if (hit == this.pc.length - 1) { this.pc[hit] = 0; }
		for (i = hit; i < this.pc.length - 1; i++) {
			this.pc[i] = this.pc[i+1];
			this.pc[i+1] = 0;
		}
	}
	if (this.pc[0] <= 0) { this.init(); }
}

// p[eB[S̒l̃`FbNƃZbg
PartyModel.prototype.check = function() {
	for (var i = 0; i < this.pc.length; i++) {
		if (this.pc[i] == 0) { break; }
		this.pcModel[this.pc[i]].check(this.protection);
	}
}

// p[eB[SMP
PartyModel.prototype.recoverMp = function() {
	var i, j, pc2;
	for (i = 0; i < this.pc.length; i++) {
		if (this.pc[i] == 0) { break; }
		pc2 = this.pcModel[this.pc[i]];
		if (pc2.state != 5 && pc2.state != 6 && pc2.state != 7) {
			for (j = 0; j < 7; j++) {
				pc2.mpM[j] = pc2.mpMMax[j];
				pc2.mpP[j] = pc2.mpPMax[j];
			}
		}
	}
}

// łACe̗]T`FbN
PartyModel.prototype.itemGetCheck = function() {
	var i, pc2, count = 0, tmp, cantMoveCheck = 0;
	var itemOk = new Array(0);
	for (i = 0; i < this.pc.length; i++) {
		if (this.pc[i] == 0) { break; }
		pc2 = this.pcModel[this.pc[i]];
		if (pc2.cantMove) {
			cantMoveCheck = 1;
			continue;
		}
		if (pc2.item[7] == 0) {
			itemOk[count] = i;
			count++;
		}
	}
	if (itemOk.length == 0 && cantMoveCheck) {
		for (i = 0; i < this.pc.length; i++) {
			if (this.pc[i] == 0) { break; }
			pc2 = this.pcModel[this.pc[i]];
			if (!pc2.cantMove || pc2.state == 7) { continue; }
			if (pc2.item[7] == 0) {
				itemOk[count] = i;
				count++;
			}
		}
	}
	if (itemOk.length == 0) { return -1; }
	else {
		tmp = dice(1,itemOk.length) - 1;
		return itemOk[tmp];
	}
}

// wACȅ`FbN
PartyModel.prototype.itemHaveCheck = function(itemNum) {
	var i, j, pc2, item, tmp = -1;
	for (i = 0; i < this.pc.length; i++) {
		if (this.pc[i] == 0) { break; }
		pc2 = this.pcModel[this.pc[i]];
		for (j = 0; j < pc2.item.length; j++) {
			if (pc2.item[j] == 0) { break; }
			item = pc2.item[j];
			if (item >= 10000) { item -= 10000; }
			if (item == itemNum) {
				tmp = i;
				break;
			}
		}
		if (tmp >= 0) { break; }
	}
	return tmp;
}

// ̗̍L`FbN
PartyModel.prototype.titleCheck = function() {
	var i, j, pc2, item, tmp = -1;
	for (i = 0; i < this.pc.length; i++) {
		if (this.pc[i] == 0) { break; }
		pc2 = this.pcModel[this.pc[i]];
		if (pc2.title == 2 && tmp < 2) { tmp = 2; }
		else if (pc2.title == 1 && tmp < 1) { tmp = 1; }
	}
	return tmp;
}

// 
PartyModel.prototype.init = function() {
	this.x = 0, this.y = 0, this.floor = 0;
	this.direction = 'north';
	this.bright = 0, this.protection = 0, this.discrimination = 0;
	this.pc = new Array(6);
	for (var i = 0; i < this.pc.length; i++) {
		this.pc[i] = 0;
	}
}

