// pc̃f[^ێ

// pcfNX
function PcModel(id) {
	this.id = id;
	this.init();
}

// 
PcModel.prototype.init = function() {
	var i, j;
	this.name = '', this.race = 0;
	this.alignment = 0, this.pcClass = 0;
	this.abi = new Array(6);
	this.abi[0] = 5, this.abi[1] = 5, this.abi[2] = 5;
	this.abi[3] = 5, this.abi[4] = 5, this.abi[5] = 5;
	this.hpMax = 10, this.hp = this.hpMax;
	this.level = 1, this.exp = 0, this.next = 0, this.gold = 0;
	this.age = 14, this.ageWeek = 100;
	this.ac = 10, this.title = 0, this.state = 0;
	this.hpPlus = 0, this.party = -1, this.cantMove = 0;
	this.silent = 0, this.action = new Array(0,0,0), this.curse = 0;
	this.dmgDiceNum = 0, this.dmgDice = 0, this.dmgDicePlus = 0;
	this.st = 0, this.at = 0, this.hide = 0, this.doubleAt = new Array(13);
	this.atDef = new Array(13), this.resist = new Array(11);
	this.crit = 0, this.noSpell = 0, this.weapon = 0, this.acPlus = 0;
	this.sleep = 0;

	this.mpM = new Array(0,0,0,0,0,0,0);
	this.mpMMax = new Array(0,0,0,0,0,0,0);
	this.mSpell = new Array();
	for (i = 0; i < 7; i++) {
		this.mSpell[i] = new Array();
		for (j = 0; j < 3; j++) {
			this.mSpell[i][j] = 0;
		}
	}
	this.mpP = new Array(0,0,0,0,0,0,0);
	this.mpPMax = new Array(0,0,0,0,0,0,0);
	this.pSpell = new Array();
	for (i = 0; i < 7; i++) {
		this.pSpell[i] = new Array();
		for (j = 0; j < 3; j++) {
			this.pSpell[i][j] = 0;
		}
	}
	this.item = new Array(0,0,0,0,0,0,0,0);
	this.itemS = new Array(0,0,0,0,0,0,0,0);
}

// xAbv
PcModel.prototype.levelUp = function() {
	var k = 0, up = new Array();
	this.level++;
	if (this.levelUpSpell()) {
		up[k] = 'VoI';
		k++;
	}

	var tmp = 90, i, abiUp = new Array(0,0,0,0,0,0);
	while (true) {
		if (dice(1, 100) <= tmp) {
			while (true) {
				if(abiUp.join('') == '111111') {
					tmp = 0;
					break;
				}
				i = dice(1, 6) - 1;
				if (abiUp[i] == 0) {
					abiUp[i] = 1;
					tmp -= 10;
					break;
				}
			}
		} else { break; }
		if (tmp <= 0) { break; }
	}
	var age = Math.floor(this.age / 3);
	for (i = 0; i < abiUp.length; i++) {
		if (abiUp[i] == 0) { continue; }
		if (dice(1, 100) < age) {
			if (this.abi[i] >= ABILITY[this.race][i] + 10) {
				if (dice(1, 100) <= 50) {
					this.abi[i]--;
					abiUp[i] = -1;
				} else { abiUp[i] = 0; }
			} else {
				this.abi[i]--;
				abiUp[i] = -1;
			}
		} else {
			if (this.abi[i] < ABILITY[this.race][i] + 10) {
				this.abi[i]++;
				abiUp[i] = 1;
			} else { abiUp[i] = 0; }
		}
	}
	for (i = 0; i < abiUp.length; i++) {
		if (abiUp[i] == 0) { continue; }
		if (abiUp[i] == 1) {
			if (i == 0) { up[k] = '͂𓾂B', k++; }
			else if (i == 1) { up[k] = 'mb𓾂B', k++; }
			else if (i == 2) { up[k] = 'MS𓾂B', k++; }
			else if (i == 3) { up[k] = '͂𓾂B', k++; }
			else if (i == 4) { up[k] = 'f𓾂B', k++; }
			else if (i == 5) { up[k] = '^̋𓾂B', k++; }
		} else {
			if (i == 0) { up[k] = '͂B', k++; }
			else if (i == 1) { up[k] = 'mbB', k++; }
			else if (i == 2) { up[k] = 'MSB', k++; }
			else if (i == 3) { up[k] = '͂B', k++; }
			else if (i == 4) { up[k] = 'fB', k++; }
			else if (i == 5) { up[k] = '^̋B', k++; }
		}
	}
	var hp = this.levelUpHp();
	hp -= this.hpMax;
	if (hp <= 0) { hp = 1; }
	up[k] = 'go' + hzNum(hp, 0) + 'オB';
	this.hp += hp, this.hpMax += hp;
	this.check();
	return up;
}

// xAbviHPZoj
PcModel.prototype.levelUpHp = function() {
	var hp, bonus = 0, classDice, min;

	if (this.abi[3] <= 3) { bonus -= 1; }
	if (this.abi[3] <= 4) { bonus -= 1; }
	if (this.abi[3] <= 5) { bonus -= 1; }
	if (this.abi[3] >= 14) { bonus += 1; }
	if (this.abi[3] >= 17) { bonus += 1; }
	if (this.abi[3] >= 20) { bonus += 1; }

	if (this.pcClass == 0) { classDice = 12, min = 7; }
	else if (this.pcClass == 1) { classDice = 4, min = 1; }
	else if (this.pcClass == 2) { classDice = 8, min = 5; }
	else if (this.pcClass == 3) { classDice = 6, min = 2; }
	else if (this.pcClass == 4) { classDice = 6, min = 2; }
	else if (this.pcClass == 5) { classDice = 10, min = 7; }
	else if (this.pcClass == 6) { classDice = 12, min = 7; }
	else if (this.pcClass == 7) { classDice = 7, min = 3; }

	hp = dice(this.level, classDice + bonus);
	if (hp <= min) { hp = min + dice(1, 3); }
	return hp;
}

// xAbviKj
PcModel.prototype.levelUpSpell = function() {
	var i, j, mR = 60, pR = 60, mL = 0, pL = 0, tmp;
	if (this.pcClass == 1) {
		if (this.level >= 17) { mL = 9; }
		else if (this.level >= 15) { mL = 8; }
		else if (this.level >= 13) { mL = 7; }
		else if (this.level >= 11) { mL = 6; }
		else if (this.level >= 9) { mL = 5; }
		else if (this.level >= 7) { mL = 4; }
		else if (this.level >= 5) { mL = 3; }
		else if (this.level >= 3) { mL = 2; }
		else if (this.level >= 1) { mL = 1; }
	} else if (this.pcClass == 4) {
		if (this.level >= 31) { mL = 9; }
		else if (this.level >= 29) { mL = 8; }
		else if (this.level >= 25) { mL = 7; }
		else if (this.level >= 21) { mL = 6; }
		else if (this.level >= 17) { mL = 5; }
		else if (this.level >= 13) { mL = 4; }
		else if (this.level >= 9) { mL = 3; }
		else if (this.level >= 5) { mL = 2; }
		else if (this.level >= 1) { mL = 1; }
	} else if (this.pcClass == 5) {
		if (this.level >= 28) { mL = 9; }
		else if (this.level >= 25) { mL = 8; }
		else if (this.level >= 22) { mL = 7; }
		else if (this.level >= 19) { mL = 6; }
		else if (this.level >= 16) { mL = 5; }
		else if (this.level >= 13) { mL = 4; }
		else if (this.level >= 10) { mL = 3; }
		else if (this.level >= 7) { mL = 2; }
		else if (this.level >= 4) { mL = 1; }
	} else {
		for (i = 6; i >= 0; i--) {
			if (this.mpMMax[i] > 0) {
				mL = i+1;
				break;
			}
		}
	}
	if (this.pcClass == 2) {
		if (this.level >= 17) { pL = 9; }
		else if (this.level >= 15) { pL = 8; }
		else if (this.level >= 13) { pL = 7; }
		else if (this.level >= 11) { pL = 6; }
		else if (this.level >= 9) { pL = 5; }
		else if (this.level >= 7) { pL = 4; }
		else if (this.level >= 5) { pL = 3; }
		else if (this.level >= 3) { pL = 2; }
		else if (this.level >= 1) { pL = 1; }
	} else if (this.pcClass == 4) {
		if (this.level >= 36) { pL = 9; }
		else if (this.level >= 32) { pL = 8; }
		else if (this.level >= 28) { pL = 7; }
		else if (this.level >= 24) { pL = 6; }
		else if (this.level >= 20) { pL = 5; }
		else if (this.level >= 16) { pL = 4; }
		else if (this.level >= 12) { pL = 3; }
		else if (this.level >= 8) { pL = 2; }
		else if (this.level >= 4) { pL = 1; }
	} else if (this.pcClass == 6) {
		if (this.level >= 20) { pL = 9; }
		else if (this.level >= 18) { pL = 8; }
		else if (this.level >= 16) { pL = 7; }
		else if (this.level >= 14) { pL = 6; }
		else if (this.level >= 12) { pL = 5; }
		else if (this.level >= 10) { pL = 4; }
		else if (this.level >= 8) { pL = 3; }
		else if (this.level >= 6) { pL = 2; }
		else if (this.level >= 4) { pL = 1; }
	} else {
		for (i = 6; i >= 0; i--) {
			if (this.mpPMax[i] > 0) {
				pL = i+1;
				break;
			}
		}
	}
	if (this.abi[1] >= 20) { mR += 10; }
	if (this.abi[1] >= 17) { mR += 10; }
	if (this.abi[1] >= 14) { mR += 10; }
	if (this.abi[1] >= 11) { mR += 10; }
	if (this.abi[2] >= 20) { pR += 10; }
	if (this.abi[2] >= 17) { pR += 10; }
	if (this.abi[2] >= 14) { pR += 10; }
	if (this.abi[2] >= 11) { pR += 10; }

	if (mR > 95) { mR = 95; }
	if (pR > 95) { pR = 95; }

	for (i = 0; i < 7; i++) {
		if (this.mpMMax[i] == 0) {
			tmp = 0;
			for (j = 0; j < 3; j++) {
				if (this.mSpell[i][j] == 1) { tmp++; }
			}
			this.mpMMax[i] = tmp;
		}
	}
	for (i = 0; i < 7; i++) {
		if (this.mpPMax[i] == 0) {
			tmp = 0;
			for (j = 0; j < 3; j++) {
				if (this.pSpell[i][j] == 1) { tmp++; }
			}
			this.mpPMax[i] = tmp;
		}
	}

	var re = 0, count, bL;
	if (mL > 0) {
		bL = mL;
		if (bL > 7) { bL = 7; }
		for (i = bL-1; i >= 0; i--) {
			if (!this.mSpell[i][0] && !this.mSpell[i][1] && !this.mSpell[i][2]) {
				if (i == 0) { this.mSpell[0][1] = 1; }
				else {  this.mSpell[i][dice(1, 3)-1] = 1; }
				this.mpMMax[i]++, re = 1;
			}
			if (this.mSpell[i][0] && this.mSpell[i][1] && this.mSpell[i][2]) {
				continue;
			}
			count = 0;
			while (true) {
				if (dice(1,100) <= mR) {
					tmp = 0;
					if (!this.mSpell[i][0]) {
						this.mSpell[i][0] = 1, tmp = 1;
					} else if (!this.mSpell[i][1]) {
						this.mSpell[i][1] = 1, tmp = 1;
					} else if (!this.mSpell[i][2]) {
						this.mSpell[i][2] = 1, tmp = 1;
					}
					if (tmp) {
						this.mpMMax[i]++;
						re = 1, mR -= 15;
						count++;
					} else { break; }
				} else { break; }
				if (count > 1) { break; }
			}
			if (mL >= i+2 && (this.mSpell[i][0] + this.mSpell[i][1] + this.mSpell[i][2] < 3)) {
				for (j = 0; j < 3; j++) {
					if (this.mSpell[i][j] == 0) {
						this.mSpell[i][j] = 1;
						this.mpMMax[i]++;
					}
				}
			}
		}
	}
	if (pL > 0) {
		bL = pL;
		if (bL > 7) { bL = 7; }
		for (i = bL-1; i >= 0; i--) {
			if (!this.pSpell[i][0] && !this.pSpell[i][1] && !this.pSpell[i][2]) {
				if (i == 0) { this.pSpell[0][0] = 1; }
				else {  this.pSpell[i][dice(1, 3)-1] = 1; }
				this.mpPMax[i]++, this.mpP[i]++, re = 1;
			}
			if (this.pSpell[i][0] && this.pSpell[i][1] && this.pSpell[i][2]) {
				continue;
			}
			count = 0;
			while (true) {
				if (dice(1,100) <= pR) {
					tmp = 0;
					if (!this.pSpell[i][0]) {
						this.pSpell[i][0] = 1, tmp = 1;
					} else if (!this.pSpell[i][1]) {
						this.pSpell[i][1] = 1, tmp = 1;
					} else if (!this.pSpell[i][2]) {
						this.pSpell[i][2] = 1, tmp = 1;
					}
					if (tmp) {
						this.mpPMax[i]++;
						re = 1, pR -= 15;
						count++;
					} else { break; }
				} else { break; }
				if (count > 1) { break; }
			}
			if (pL >= i+2 && (this.pSpell[i][0] + this.pSpell[i][1] + this.pSpell[i][2] < 3)) {
				for (j = 0; j < 3; j++) {
					if (this.pSpell[i][j] == 0) {
						this.pSpell[i][j] = 1;
						this.mpPMax[i]++;
					}
				}
			}
		}
	}

	this.mpUp();

	if (re) { return true; }
	else { return false; }
}

// őMP̃Zbg
PcModel.prototype.mpUp = function() {
	var i, j, mp, plus;
	var mpUp = new Array(0);
	if (this.pcClass == 1) { mpUp = new Array(5,7,9,11,13,15,17); }
	else if (this.pcClass == 4) { mpUp = new Array(5,9,13,17,21,25,29); }
	else if (this.pcClass == 5) { mpUp = new Array(8,11,14,17,20,23,26); }
	j = 0;
	if (this.abi[1] >= 14) { j += 1; }
	if (this.abi[1] >= 17) { j += 1; }
	if (this.abi[1] >= 20) { j += 1; }
	for (i = 0; i < mpUp.length; i++) {
		mpUp[i] -= j;
	}
	for (i = 6; i >= 0; i--) {
		if (mpUp.length > 0) {
			if (this.level >= mpUp[i]) {
				plus = this.level - mpUp[i]+1;
			} else { plus = 0; }
		} else { plus = 0; }
		mp = this.mSpell[i][0] + this.mSpell[i][1] + this.mSpell[i][2];
		if (mp > 0 && this.mpMMax[i] < mp + plus) {
			this.mpMMax[i] = mp + plus;
		}
	}
	mpUp = new Array(0)
	if (this.pcClass == 2) { mpUp = new Array(5,7,9,11,13,15,17); }
	else if (this.pcClass == 4) { mpUp = new Array(8,12,16,20,24,28,32); }
	else if (this.pcClass == 6) { mpUp = new Array(8,10,12,14,16,18,20); }
	j = 0;
	if (this.abi[2] >= 14) { j += 1; }
	if (this.abi[2] >= 17) { j += 1; }
	if (this.abi[2] >= 20) { j += 1; }
	for (i = 0; i < mpUp.length; i++) {
		mpUp[i] -= j;
	}
	for (i = 6; i >= 0; i--) {
		if (mpUp.length > 0) {
			if (this.level >= mpUp[i]) {
				plus = this.level - mpUp[i]+1;
			} else { plus = 0; }
		} else { plus = 0; }
		mp = this.pSpell[i][0] + this.pSpell[i][1] + this.pSpell[i][2];
		if (mp > 0 && this.mpPMax[i] < mp + plus) {
			this.mpPMax[i] = mp + plus;
		}
	}

	for (i = 0; i < 7; i++) {
		if (this.mpMMax[i] > 9) { this.mpMMax[i] = 9; }
		if (this.mpPMax[i] > 9) { this.mpPMax[i] = 9; }
	}
}

// hp̐
PcModel.prototype.hpCtrl = function(n) {
	this.hp += n;
	if (this.state == 5 || this.state == 6 || this.state == 7) {
		this.hp = 0;
	} else {
		if (this.hp > this.hpMax) { this.hp = this.hpMax; }
		else if (this.hp <= 0) {
			this.hp = 0;
			if (this.state != 6 && this.state != 7) {
				this.state = 5;
			}
			this.hide = 2, this.silent = 0;
			if (this.state == 2 || this.state == 3 || this.state == 4 || this.state == 5 || this.state == 6 || this.state == 7 || this.state == 12 || this.state == 13 || this.state == 14) {
				this.cantMove = 1;
			} else { this.cantMove = 0; }
		}
	}
}

// ACe
PcModel.prototype.getItem = function(itemNum) {
	var i;
	for (i = 0; i < this.item.length; i++) {
		if (this.item[i] == 0) {
			this.item[i] = itemNum;
			this.itemS[i] = 0;
			break;
		}
	}
}

// ACe
PcModel.prototype.deleteItem = function(num) {
	var i;
	this.item[num] = 0;
	this.itemS[num] = 0;
	for (i = num+1; i < this.item.length; i++) {
		this.item[i-1] = this.item[i];
		this.itemS[i-1] = this.itemS[i];
		this.item[i] = 0;
		this.itemS[i] = 0;
	}
}

// xhC
PcModel.prototype.lvDrain = function(downLv) {
	this.level -= downLv;
	var i = 0, j, exp = 0;
	while(i < this.level - 1) {
		if (i < 12) { j = i; }
		else { j = 12; }
		exp += LU_EXP[this.pcClass][j];
		i++;
	}
	this.exp = exp;
	this.hpMax = this.levelUpHp();
	this.hpCtrl(0);
}

// l̃`FbNƃZbg
PcModel.prototype.check = function(protection) {
	var i, j, tmp;
	if (protection == null) { protection = 0; }

	if (this.exp > 999999999999) { this.exp = 999999999999; }
	if (this.gold > 999999999999) { this.gold = 999999999999; }
	if (this.hpMax > 9999) { this.hpMax = 9999; }
	if (this.hp > 9999) { this.hp = 9999; }

	this.hpCtrl(0);
	this.age = Math.floor(this.ageWeek / 50) + 12;
	i = 0, tmp = 0;
	while(i < this.level) {
		if (i < 12) { j = i; }
		else { j = 12; }
		tmp += LU_EXP[this.pcClass][j];
		i++;
	}
	this.next = tmp - this.exp;
	if (this.next < 0) { this.next = 0; }
	if (this.state == 2 || this.state == 3 || this.state == 4 || this.state == 5 || this.state == 6 || this.state == 7 || this.state == 12 || this.state == 13 || this.state == 14) {
		this.cantMove = 1;
	} else { this.cantMove = 0; }

	this.curse = 0, this.dmgDiceNum = 1, this.dmgDice = 3;
	this.dmgDicePlus = 0, this.st = this.abi[0], this.ac = 10;
	this.hpPlus = 0, this.crit = 0, this.noSpell = 0, this.weapon = 0;
	if (this.pcClass == 0 || this.pcClass == 5 || this.pcClass == 6) {
		this.at = 1 + Math.floor(this.level / 5);
		if (this.at > 8) { this.at = 8; }
	} else if (this.pcClass == 7) {
		this.at = 2 + Math.floor(this.level / 5);
		if (this.at > 12) { this.at = 12; }
		this.crit = 1, tmp = Math.floor(this.level / 5);
		if (tmp > 20) { tmp = 20; }
		this.dmgDice += tmp;
		this.weapon = 10;
		tmp = Math.floor(this.level / 3);
		if (tmp > 30) { tmp = 30; }
		this.ac -= tmp;
	} else {
		this.at = 1 + Math.floor(this.level / 5);
		if (this.at > 6) { this.at = 6; }
	}
	for (i = 0; i < this.doubleAt.length; i++) {
		this.doubleAt[i] = 0;
		this.atDef[i] = 0;
	}
	for (i = 0; i < this.resist.length; i++) {
		this.resist[i] = 0;
	}

	var item;
	for (i = 0; i < this.itemS.length; i++) {
		if (this.itemS[i]) {
			this.ac = 10;
			break;
		}
	}
	if (this.party >= 0) {
		if (protection) { this.ac -= 2; }
	}
	if (this.state >= 10) { this.hpPlus--; }
	var curse, doubleAt, atDef, resist;
	for (i = 0; i < this.item.length; i++) {
		if (this.item[i] == 0) { break; }
		item = itemData(this.item[i]);
		curse = NtoP(item[4]);
		this.hpPlus += item[14];
		if (this.itemS[i]) {
			if (curse[this.alignment]) {
				this.curse = 1;
				this.ac += item[22];
			} else { this.ac += item[5]; }
			if (item[0] == 1) {
				this.weapon = item[2];
				this.dmgDiceNum = item[8];
				this.dmgDice = item[9];
				this.dmgDicePlus = item[10];
			}
			this.st += item[6];
			if (this.at < item[7]) { this.at = item[7]; }
			if (item[13]) { this.crit = 1; }
			this.noSpell += item[16];
		}
		doubleAt = NtoP(item[12]);
		atDef = NtoP(item[15]);
		for (j = 0; j < doubleAt.length; j++) {
			if (doubleAt[j]) { this.doubleAt[j] = 1; }
		}
		for (j = 0; j < atDef.length; j++) {
			if (atDef[j]) { this.atDef[j] = 1; }
		}
		resist = NtoP(item[17]);
		for (j = 0; j < resist.length; j++) {
			if (resist[j]) { this.resist[j] = 1; }
		}
	}
	this.ac += this.acPlus;
	if (this.ac > 99) { this.ac = 99; }
	else if (this.ac < -99) { this.ac = -99; }

}


